unit ChartLin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,  Series, ColorGrd, Spin, Buttons;

type
  TfmLines = class(TForm)
    ComboBox1: TComboBox;
    RadioGroup1: TRadioGroup;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    ColorDialog1: TColorDialog;
    BitBtn1: TBitBtn;
    procedure ComboBox1Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Index: Integer;
    Procedure Enter;
  end;

var
  fmLines: TfmLines;

implementation

uses ChartMy;

{$R *.DFM}
Procedure TfmLines.Enter;
  var I: integer;
begin
   if fmChart.Chart.SeriesCount = 0 then exit;
   ComboBox1.Items.Clear;
   for  I:=0 to fmChart.Chart.SeriesCount-1 do
            ComboBox1.Items.Add(fmChart.Chart.Series[I].Title);
   ComboBox1.ItemIndex:=0;
   ComboBox1Change(ComboBox1);
   ShowModal;
end;

procedure TfmLines.ComboBox1Change(Sender: TObject);
begin
   Index:=ComboBox1.ItemIndex;
     case TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style of
         psSolid: RadioGroup1.ItemIndex:=0;
         psDash:  RadioGroup1.ItemIndex:=1;
         psDot :   RadioGroup1.ItemIndex:=2;
         psDashDot:   RadioGroup1.ItemIndex:=3;
         psDashDotDot:  RadioGroup1.ItemIndex:=4;
         end;
    SpinEdit1.Value:=TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Width;
    Image1.Canvas.Brush.Color :=TFastLineSeries(fmChart.Chart.Series[Index]).SeriesColor;
    Image1.Canvas.FillRect(Image1.ClientRect);
end;

procedure TfmLines.RadioGroup1Click(Sender: TObject);
begin
   case RadioGroup1.ItemIndex of
      0:    TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style:=psSolid;
      1:    TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style:=psDash;
      2:    TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style:=psDot;
      3:    TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style:=psDashDot;
      4:    TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Style:=psDashDotDot;
      end;
end;

procedure TfmLines.SpinEdit1Change(Sender: TObject);
begin
  if SpinEdit1.Value = 1 then RadioGroup1.Enabled:=true
                         else RadioGroup1.Enabled:=false;
   TFastLineSeries(fmChart.Chart.Series[Index]).LinePen.Width:=SpinEdit1.Value;


end;

procedure TfmLines.Image1DblClick(Sender: TObject);
begin
 ColorDialog1.Color:= TFastLineSeries(fmChart.Chart.Series[Index]).SeriesColor;
 if ColorDialog1.Execute then  begin
   TFastLineSeries(fmChart.Chart.Series[Index]).SeriesColor:= ColorDialog1.Color;
    Image1.Canvas.Brush.Color :=TFastLineSeries(fmChart.Chart.Series[Index]).SeriesColor;
    Image1.Canvas.FillRect(Image1.ClientRect);
   end;
end;

end.
