unit D3CellParms;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfmSellParms = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowParams(X,Y,Z: Integer);
    procedure GetVoltageSourseResistens(X,Y,Z: Integer);
  end;

var
  fmSellParms: TfmSellParms;

implementation

uses N3dMain, D3OpenMain;

{$R *.DFM}
procedure TfmSellParms.ShowParams(X,Y,Z: Integer);
begin
  Memo1.Clear;
  Memo1.Lines.Add(' (X, Y, Z): '+IntToStr(X)+', '+IntToStr(Y)+', '+IntToStr(Z));
  GetVoltageSourseResistens(X,Y,Z);
  Show;
end;

procedure TfmSellParms.GetVoltageSourseResistens(X,Y,Z: Integer);
   var dX,dY,dZ : double;
       Err1,Err2,Err3: Integer;
       Rx,Ry,Rz: double;
       StEr: String;
       Error: boolean;
begin
 Error:=False;
 StEr:=' ';
 Val(fmNew3dMain.edX.Text,dX,Err1);
 if Err1>0 then StEr:=StEr+'    , ';
 Val(fmNew3dMain.edY.Text,dY,Err2);
 if Err2>0 then StEr:=StEr+'    Y, ';
 Val(fmNew3dMain.edZ.Text,dZ,Err3);
 if Err3>0 then StEr:=StEr+'    Z, ';
 if (Err1>0)or(Err2>0)or(Err3>0) then  Error:=True;

 if Error then begin
               Memo1.Lines.Add(StEr);
               Exit;
               end;

 if (dX<=0)or(dY<=0)or(dZ<=0) then
               begin
               Memo1.Lines.Add('   ');
               Exit;
               end;

 if fmOpenGL.Space[X,Y,Z] <>0
 then begin
   Memo1.Lines.Add(' : ');
   Rx:= dX/
     (fmOpenGL.Layers[fmOpenGL.Space[X,Y,Z]].Sig * dY * dZ);
   Ry:= dY/
     (fmOpenGL.Layers[fmOpenGL.Space[X,Y,Z]].Sig * dX * dZ);
   Rz:= dZ/
     (fmOpenGL.Layers[fmOpenGL.Space[X,Y,Z]].Sig * dX * dY);
   Memo1.Lines.Add('    X '+  FloatToStrF(Rx,ffGeneral,6,2) + ' ');
   Memo1.Lines.Add('    Y '+  FloatToStrF(Ry,ffGeneral,6,2) + ' ');
   Memo1.Lines.Add('    Z '+  FloatToStrF(Rz,ffGeneral,6,2) + ' ');
      end
 else
   Memo1.Lines.Add(' : ');
end;

procedure TfmSellParms.Button1Click(Sender: TObject);
begin
 Close;
end;

end.
