unit D3Layers;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, Grids, Buttons, ExtCtrls;

type
  TfmLayers = class(TForm)
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    btnSave: TBitBtn;
    btnAddLayer: TBitBtn;
    ColorDialog1: TColorDialog;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure btnAddLayerClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure BitBtn1Click(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    CanExit: boolean;
  end;

var
  fmLayers: TfmLayers;

implementation

uses D3OpenMain, N3dUtils, N3dMain;

{$R *.DFM}

procedure TfmLayers.FormActivate(Sender: TObject);
 var i : integer;
var
  myRect: TGridRect;
begin
  CanExit:=False;
  StringGrid1.RowCount:=fmOpenGL.LayerCount+1;
  StringGrid1.Cells[0,0]:='';
  StringGrid1.Cells[1,0]:='';
  StringGrid1.Cells[2,0]:='. .';
  StringGrid1.Cells[3,0]:='.';
  StringGrid1.Cells[4,0]:='. .';
  StringGrid1.Cells[5,0]:=' ()';
    for i:=1 to fmOpenGL.LayerCount do begin
      StringGrid1.Cells[1,i]:='';
      if not fmOpenGL.Layers[i].Visible then StringGrid1.Cells[1,i]:='';
      StringGrid1.Cells[2,i]:=FloatToStr(fmOpenGL.Layers[i].Eps);
      StringGrid1.Cells[3,i]:=FloatToStr(fmOpenGL.Layers[i].Sig);
      StringGrid1.Cells[4,i]:=FloatToStr(fmOpenGL.Layers[i].Mu);
      StringGrid1.Cells[5,i]:=fmOpenGL.Layers[i].Comment;

      end;
  myRect.Left := 5;
  myRect.Top := fmOpenGL.LayerCurrent;
  myRect.Right := 5;
  myRect.Bottom := fmOpenGL.LayerCurrent;
  StringGrid1.Selection := myRect;
  Caption:=' :'+fmOpenGL.Layers[fmOpenGL.LayerCurrent].Comment;

end;

procedure TfmLayers.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
 if ARow=0 then exit;
 with StringGrid1.Canvas do begin
   if ACol=0 then begin
     Brush.Color:=fmOpenGL.Layers[ARow].Color;
     FillRect(Rect);
     Pen.Width:=3;
     Pen.Color:= not Brush.Color;
     if (ARow = fmOpenGL.LayerCurrent)and(ACol=0) then Rectangle(Rect);
     TextOut(Rect.Left+5,Rect.Top+2, IntToStr(ARow));
     end;
   end;
end;

procedure TfmLayers.btnSaveClick(Sender: TObject);
 var i : integer;
begin
  CanExit:=True;
   try
    for i:=1 to StringGrid1.RowCount-1 do begin
      fmOpenGL.Layers[i].Eps:=StrToFloat(StringGrid1.Cells[2,i]);
      fmOpenGL.Layers[i].Sig:=StrToFloat(StringGrid1.Cells[3,i]);
      fmOpenGL.Layers[i].Mu :=StrToFloat(StringGrid1.Cells[4,i]);
      fmOpenGL.Layers[i].Comment :=StringGrid1.Cells[5,i];
      end;
    except
      CanExit:=False;
      ShowMessage(' !');
    end;
end;

procedure TfmLayers.FormCreate(Sender: TObject);
 var i : integer;
begin
  StringGrid1.Cells[0,0]:='';
  StringGrid1.Cells[1,0]:='';
  StringGrid1.Cells[2,0]:='. ';
  StringGrid1.Cells[3,0]:=', /';
  StringGrid1.Cells[4,0]:='. ';
    i:=1;
  StringGrid1.Cells[1,i]:='';
  StringGrid1.Cells[2,i]:=FloatToStr(fmOpenGL.Layers[i].Eps);
  StringGrid1.Cells[3,i]:=FloatToStr(fmOpenGL.Layers[i].Sig);
  StringGrid1.Cells[4,i]:=FloatToStr(fmOpenGL.Layers[i].Mu);

end;

procedure TfmLayers.btnColorClick(Sender: TObject);
begin
  if not ColorDialog1.Execute then exit;
  fmOpenGL.Layers[fmOpenGL.LayerCurrent].Color:=ColorDialog1.Color;
  StringGrid1.Repaint;
end;

procedure TfmLayers.btnAddLayerClick(Sender: TObject);
begin
  btnSaveClick(nil);
  if not CanExit then exit;
  inc(fmOpenGL.LayerCount);
  fmOpenGL.LayerCurrent:=fmOpenGL.LayerCount;
  StringGrid1.RowCount:=fmOpenGL.LayerCount+1;
  FormActivate(nil);
  StringGrid1.Repaint;
end;

procedure TfmLayers.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 btnSaveClick(nil);
 CanClose:=CanExit;
end;

procedure TfmLayers.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin

  if ARow=0 then exit;
 fmOpenGL.LayerCurrent:=ARow;
 with StringGrid1 do begin
    if ACol<2 then   CanSelect:=False;
    if ACol=0 then  btnColorClick(nil);
    if ACol=1 then
       begin
         fmOpenGL.Layers[ARow].Visible := not  fmOpenGL.Layers[ARow].Visible;
         StringGrid1.Cells[1,ARow]:='';
         if not fmOpenGL.Layers[ARow].Visible then StringGrid1.Cells[1,ARow]:='';
       end;
    end;
  StringGrid1.Repaint;
end;


procedure TfmLayers.BitBtn1Click(Sender: TObject);
  var i,j,k: Integer;
      Yes: boolean;
begin
 if fmOpenGL.LayerCount=1 then exit;

 Yes:=False;
 for I:=1 to xsize do
   for j:=1 to ysize do
      for k:=1 to zsize do begin

         if fmOpenGL.Space[i,j,k] = fmOpenGL.LayerCurrent then
              if (not Yes) then begin
                   if MessageDLG(' ,   ?',
                     mtConfirmation,[mbOK,mbCancel],0 )<>mrOk then Exit;
                   fmOpenGL.SaveUndo;
                   Yes:=True;
                   fmOpenGL.Space[i,j,k]:=0;
                   end
                   else fmOpenGL.Space[i,j,k]:=0;
        end;

 if (fmOpenGL.LayerCurrent< fmOpenGL.LayerCount) then begin
  for i:=fmOpenGL.LayerCurrent+1 to fmOpenGL.LayerCount do
           begin
           fmOpenGL.Layers[i-1].Color:=fmOpenGL.Layers[i].Color;
           fmOpenGL.Layers[i-1].visible:=fmOpenGL.Layers[i].visible;
           fmOpenGL.Layers[i-1].Sig:=fmOpenGL.Layers[i].Sig;
           fmOpenGL.Layers[i-1].Eps:=fmOpenGL.Layers[i].Eps;
           fmOpenGL.Layers[i-1].Mu:=fmOpenGL.Layers[i].Mu;
           fmOpenGL.Layers[i-1].Comment:=fmOpenGL.Layers[i].Comment;
           end;
  for I:=1 to xsize do
    for j:=1 to ysize do
      for k:=1 to zsize do
         if fmOpenGL.Space[i,j,k] >fmOpenGL.LayerCurrent
              then fmOpenGL.Space[i,j,k]:=fmOpenGL.Space[i,j,k]-1;
   end;

 if    (fmOpenGL.LayerCurrent=fmOpenGL.LayerCount)
         then
              fmOpenGL.LayerCurrent:=fmOpenGL.LayerCurrent-1;
  fmOpenGL.LayerCount:= fmOpenGL.LayerCount-1;
  FormActivate(nil);
  StringGrid1.Repaint;
end;

procedure TfmLayers.StringGrid1Click(Sender: TObject);
 var i,j,k: Integer;
     myRect: TGridRect;
begin
  k:=0;
  j:=0;
   try
    for i:=1 to StringGrid1.RowCount-1 do begin
       j:=i;
       k:=2;
      fmOpenGL.Layers[i].Eps:=StrToFloat(StringGrid1.Cells[2,i]);
      inc(k);
      fmOpenGL.Layers[i].Sig:=StrToFloat(StringGrid1.Cells[3,i]);
      inc(k);
      fmOpenGL.Layers[i].Mu :=StrToFloat(StringGrid1.Cells[4,i]);
      fmOpenGL.Layers[i].Comment :=StringGrid1.Cells[5,i];
      end;
    except
  myRect.Left := k;
  myRect.Top := j;
  myRect.Right := k;
  myRect.Bottom := j;
  StringGrid1.Selection := myRect;
      ShowMessage('!');
    end;

end;

procedure TfmLayers.BitBtn2Click(Sender: TObject);

  var M,i,j,k: Integer;
      Yes: boolean;
begin


  M:=1;
 while M<=fmOpenGL.LayerCount  do begin

 if fmOpenGL.LayerCount=1 then begin
         Break;
         end;

 Yes:=False;
 for I:=1 to xsize do
   for j:=1 to ysize do
      for k:=1 to zsize do begin
         if fmOpenGL.Space[i,j,k] = M then   Yes:=True;
        end;

  if Yes then inc(M);
  if Yes then Continue;

 if (M < fmOpenGL.LayerCount) then begin
  for i:=M+1 to fmOpenGL.LayerCount do
           begin
           fmOpenGL.Layers[i-1].Color:=fmOpenGL.Layers[i].Color;
           fmOpenGL.Layers[i-1].visible:=fmOpenGL.Layers[i].visible;
           fmOpenGL.Layers[i-1].Sig:=fmOpenGL.Layers[i].Sig;
           fmOpenGL.Layers[i-1].Eps:=fmOpenGL.Layers[i].Eps;
           fmOpenGL.Layers[i-1].Mu:=fmOpenGL.Layers[i].Mu;
           fmOpenGL.Layers[i-1].Comment:=fmOpenGL.Layers[i].Comment;
           end;

  for I:=1 to xsize do
    for j:=1 to ysize do
      for k:=1 to zsize do
         if fmOpenGL.Space[i,j,k] > M
              then fmOpenGL.Space[i,j,k]:=fmOpenGL.Space[i,j,k]-1;
   end;

  if (M=fmOpenGL.LayerCount)  then  fmOpenGL.LayerCurrent:=fmOpenGL.LayerCurrent-1;

  fmOpenGL.LayerCount:= fmOpenGL.LayerCount-1;
End;
         FormActivate(nil);
         StringGrid1.Repaint;

end;

procedure TfmLayers.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
fmNew3dMain. ProjectEdited:=True;
end;

end.
