unit D3Param;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TfmParam = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    spX: TSpinEdit;
    spY: TSpinEdit;
    Label3: TLabel;
    spZ: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    cbDirection: TComboBox;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure spXChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Resistens: Real;
    procedure GetVoltageSourseResistens;
  end;

var
  fmParam: TfmParam;

implementation

uses N3dUtils, D3OpenMain, N3dMain;

{$R *.DFM}
procedure TfmParam.GetVoltageSourseResistens;
   var X,Y,Z : double;
       Err1,Err2,Err3: Integer;
       StEr: String;
begin
 Error:=False;
 StEr:=' ';
 Val(fmNew3dMain.edX.Text,X,Err1);
 if Err1>0 then StEr:=StEr+'    , ';
 Val(fmNew3dMain.edY.Text,Y,Err2);
 if Err2>0 then StEr:=StEr+'    Y, ';
 Val(fmNew3dMain.edZ.Text,Z,Err3);
 if Err3>0 then StEr:=StEr+'    Z, ';
 if (Err1>0)or(Err2>0)or(Err3>0) then  Error:=True;

 if Error then begin
               Label6.Caption:=StEr;
               Exit;
               end;

 if (X<=0)or(Y<=0)or(Z<=0) then
               begin
               Label6.Caption:='   ';
               Exit;
               end;

 if fmOpenGL.Space[spX.Value,spY.Value,spZ.Value] <>0
 then begin
 Case  cbDirection.ItemIndex of
   0: Resistens:= X/
     (fmOpenGL.Layers[fmOpenGL.Space[spX.Value,spY.Value,spZ.Value]].Sig * Y * Z);
   1: Resistens:= Y/
     (fmOpenGL.Layers[fmOpenGL.Space[spX.Value,spY.Value,spZ.Value]].Sig * X * Z);
   2: Resistens:= Z/
     (fmOpenGL.Layers[fmOpenGL.Space[spX.Value,spY.Value,spZ.Value]].Sig * X * Y);
   end;
 Label6.Caption:='  : '+
                  FloatToStrF(Resistens,ffGeneral,6,2) + ' ';
      end            
 else
   Label6.Caption:='  : ';
end;

procedure TfmParam.FormCreate(Sender: TObject);
begin
  spX.MaxValue:=NX;
  spY.MaxValue:=NY;
  spZ.MaxValue:=NZ;
  cbDirection.ItemIndex:=1;
end;

procedure TfmParam.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TfmParam.FormActivate(Sender: TObject);
begin
 GetVoltageSourseResistens;
end;

procedure TfmParam.spXChange(Sender: TObject);
begin
GetVoltageSourseResistens;
end;

end.
