unit D3Visual;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin;

type
  TfmVisual = class(TForm)
    seOutputRate: TSpinEdit;
    Label25: TLabel;
    imageRGroup: TRadioGroup;
    ImageX: TImage;
    spX: TSpinEdit;
    Label1: TLabel;
    cbVisualOn: TCheckBox;
    cbModul: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    spY: TSpinEdit;
    Label10: TLabel;
    spZ: TSpinEdit;
    ImageY: TImage;
    ImageZ: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    imPalette: TImage;
    SpinEdit1: TSpinEdit;
    Label4: TLabel;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure seOutputRateChange(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
       OutputRate: Integer;
       pageX,pagey,pagez:integer;//the page number to draw
       Max,Min: Real;
       RGBTable   :array [0..765] of integer;  //the color table
       pic        :Tbitmap;
       procedure Visual(StepNo: Integer; T: Single);
       function GetCurrentValue(x,y,z: Integer): Single;
       procedure CreatePalette;
  end;

var
  fmVisual: TfmVisual;

implementation

uses N3dUtils;

{$R *.DFM}
procedure TfmVisual.CreatePalette;
  var ZeroIndex,index,i,J:integer;
begin
//RGB table;
  for index:=0 to 765 do
    begin
      //You may change the index rgb table as you like
      if index <=255 then  RGBtable[index]:=RGB(0,index,255);
      if (index >=256)and(index<=510) then RGBtable[index]:=RGB(index-255,255,255+255-index);//  3v
      if (index >=510)and(index<=765) then RGBtable[index]:=RGB(255,255-index+510,0); //  3v
    end;
    if   (min<=0) and (max>=0) then
      begin
        ZeroIndex:=round( (765/(max-min)) * (0-min)); // 
        RGBtable[ZeroIndex]:=RGB(0,0,0);
      end;

  for i:=0 to 382 do
     for J:=0 to imPalette.Width-1 do
    begin
     imPalette.canvas.pixels[J,I]:=RGBtable[765-i*2];
    end;
end;

procedure TfmVisual.FormCreate(Sender: TObject);
begin
    pic:=Tbitmap.Create;        //create the canvas named "pic" as buffer for draw image
    pic.Canvas.Brush.Color:=clblack;
    seOutputRateChange(nil);
    SpinEdit1Change(nil);
end;

procedure TfmVisual.seOutputRateChange(Sender: TObject);
begin
  OutputRate:=seOutputRate.Value;
end;

procedure TfmVisual.SpinEdit1Change(Sender: TObject);
begin
  if SpinEdit1.Value=0 then begin
                       SpinEdit1.Value:=9;
                       SpinEdit2.Value:=SpinEdit2.Value-1;
                       end;
  if SpinEdit1.Value=10 then begin
                       SpinEdit1.Value:=1;
                       SpinEdit2.Value:=SpinEdit2.Value+1;
                       end;
  Max:=StrToFloat( IntToStr(SpinEdit1.Value)+'e'+ IntToStr(SpinEdit2.Value));
  Min:=-StrToFloat( IntToStr(SpinEdit1.Value)+'e'+ IntToStr(SpinEdit2.Value));
  if cbModul.Checked then min:=0;
  CreatePalette;
end;

function TfmVisual.GetCurrentValue(x,y,z: Integer): Single;
begin
  Result:=0;
    case imageRgroup.ItemIndex of
     0: Result:=Ex[x,y,z];
     1: Result:=Ey[x,y,z];
     2: Result:=Ez[x,y,z];
     3: Result:=Hx[x,y,z];
     4: Result:=Hy[x,y,z];
     5: Result:=Hz[x,y,z];
     6: Result:=EX[x,y,z]*dY*dZ*Sig[x,y,z];
     7: Result:=EY[x,y,z]*dX*dZ*Sig[x,y,z];
     8: Result:=EZ[x,y,z]*dX*dY*Sig[x,y,z];
     9: Result:=EX[x,y,z]*Sig[x,y,z];
     10: Result:=EY[x,y,z]*Sig[x,y,z];
     11: Result:=EZ[x,y,z]*Sig[x,y,z];
     12: Result:=Sqrt(Sqr(Ex[x,y,z])+Sqr(Ey[x,y,z])+Sqr(Ez[x,y,z]));//E
     13: Result:=Sqrt(Sqr(Hx[x,y,z])+Sqr(Hy[x,y,z])+Sqr(Hz[x,y,z]));//H
     14: Result:=Sqrt(Sqr(Ex[x,y,z]*dZ*dY)+Sqr(Ey[x,y,z]*dX*dZ)+Sqr(Ez[x,y,z]*dX*dY))*Sig[x,y,z];//I
     15: Result:=Sqrt(Sqr(Ex[x,y,z])+Sqr(Ey[x,y,z])+Sqr(Ez[x,y,z]))*Sig[x,y,z];//J
     end;
end;

procedure TfmVisual.Visual(StepNo: Integer; T: Single);
  var i,j,k,x,y,z,colorindex:integer;
      CurrentValue: FloatType;
begin
  if not cbVisualOn.Checked then exit;
  if not fmVisual.Visible then exit;
  if (StepNo mod OutputRate)<> 0 then exit;
    if Max = Min then begin
               Caption:=' , .. MAX=MIN ';
               exit;
               end;

    Caption:=': '+IntToStr(StepNo)+', : '+FloatToStrF(T/C*1e9,ffGeneral, 5,2);

    pic.width:=0; pic.height:=0;
    pic.Width:=ZSize-1;
    pic.Height:=YSize-1;
    I:=spX.Value;
    for K:=1 to ZSize-1 do
    for j:=1 to YSize-1 do
    begin
     CurrentValue:=GetCurrentValue(i,j,k);
     if cbModul.Checked then CurrentValue:=abs(CurrentValue);
     if (CurrentValue<min) then CurrentValue:=min;
     if (CurrentValue>max) then CurrentValue:=max;
     colorindex:=round( (765/(max-min)) * (CurrentValue-min)); //2v
     z:=k-1;
     y:=YSize-1-j;
     pic.canvas.pixels[z,y] := RGBtable[colorindex];
    end;
     ImageX.Picture.Bitmap:=pic;


    pic.width:=0; pic.height:=0;
    pic.Width:=ZSize-1;
    pic.Height:=XSize-1;
    J:=spY.Value;
    for K:=1 to ZSize-1 do
    for I:=1 to XSize-1 do
    begin
     CurrentValue:=GetCurrentValue(i,j,k);
     if cbModul.Checked then CurrentValue:=abs(CurrentValue);
     if (CurrentValue<min) then CurrentValue:=min;
     if (CurrentValue>max) then CurrentValue:=max;
     colorindex:=round( (765/(max-min)) * (CurrentValue-min)); //2v
     z:=K-1;
     x:=XSize-1-i;
     pic.canvas.pixels[z,x] := RGBtable[colorindex];
    end;
     ImageY.Picture.Bitmap:=pic;

    pic.width:=0; pic.height:=0;
    pic.Width:=XSize-1;
    pic.Height:=YSize-1;
    K:=spZ.Value;
    for I:=1 to XSize-1 do
    for j:=1 to YSize-1 do
    begin
     CurrentValue:=GetCurrentValue(i,j,k);
     if cbModul.Checked then CurrentValue:=abs(CurrentValue);
     if (CurrentValue<min) then CurrentValue:=min;
     if (CurrentValue>max) then CurrentValue:=max;
     colorindex:=round( (765/(max-min)) * (CurrentValue-min)); //2v
     x:=I-1;
     y:=YSize-1-j;
     pic.canvas.pixels[x,y] := RGBtable[colorindex];
    end;
     ImageZ.Picture.Bitmap:=pic;
end;



end.
