unit N3dUtils;
interface
uses classes, Dialogs, SysUtils;
const
//      NX=  160;   //       160 x 650 x 160
//      NY=  650;   //  
//      NZ=  160;   //  
      NX=  60;   //  
      NY=  200;   //  
      NZ=  110;   //  

      NX1= NX-1;
      NY1= NY-1;
      NZ1= NZ-1;

      MBegin=1; //  
type
//      FloatType = double;
        FloatType = single;
//      FloatType = extended;
      tDoubleArray = array of FloatType;
Const C = 2.997925E+8 ;
      EPSW = 1.E+7/4./PI/C;                     //EPS  * C
      SIGW = 0.0;                 //SIG , /
      MU = 4.E-7*PI*C;               //MU  * 
type
     tMaxJArray  = array[MBegin..NX1,MBegin..NY1,MBegin..NZ1] of FloatType;


     tHX = array[MBegin..NX,MBegin..NY1,MBegin..NZ1] of FloatType;
     tHY = array[MBegin..NX1,MBegin..NY,MBegin..NZ1] of FloatType;
     tHZ = array[MBegin..NX1,MBegin..NY1,MBegin..NZ] of FloatType;
     tEX = array[MBegin..NX1,MBegin..NY,MBegin..NZ]  of FloatType;
     tEY = array[MBegin..NX,MBegin..NY1,MBegin..NZ]  of FloatType;
     tEZ = array[MBegin..NX,MBegin..NY,MBegin..NZ1]  of FloatType;
   //     
     tEXYZ = array[MBegin..NX,MBegin..NY,MBegin..NZ]  of FloatType;
   //      
     tEZX = array[MBegin..NY,MBegin..NZ1] of FloatType;
     tEYX = array[MBegin..NY1,MBegin..NZ] of FloatType;
     tEZY = array[MBegin..NX,MBegin..NZ1] of FloatType;
     tEXY = array[MBegin..NX1,MBegin..NZ]  of FloatType;
     tEYZ = array[MBegin..NX,MBegin..NY1]  of FloatType;
     tEXZ = array[MBegin..NX1,MBegin..NY]  of FloatType;
    //  RT-ABC
     tEZX_3 = array[2..2,MBegin..NY,MBegin..NZ1] of FloatType;
     tEYX_3 = array[2..2,MBegin..NY1,MBegin..NZ] of FloatType;
     tEZY_3 = array[2..2,MBegin..NX,MBegin..NZ1] of FloatType;
     tEXY_3 = array[2..2,MBegin..NX1,MBegin..NZ]  of FloatType;
     tEYZ_3 = array[2..2,MBegin..NX,MBegin..NY1]  of FloatType;
     tEXZ_3 = array[2..2,MBegin..NX1,MBegin..NY]  of FloatType;
      //    
     tEZX_2 = array[1..3,MBegin..NY,MBegin..NZ1] of FloatType;
     tEYX_2 = array[1..3,MBegin..NY1,MBegin..NZ] of FloatType;
     tEZY_2 = array[1..3,MBegin..NX,MBegin..NZ1] of FloatType;
     tEXY_2 = array[1..3,MBegin..NX1,MBegin..NZ]  of FloatType;
     tEYZ_2 = array[1..3,MBegin..NX,MBegin..NY1]  of FloatType;
     tEXZ_2 = array[1..3,MBegin..NX1,MBegin..NY]  of FloatType;
      //    
     tEZX_1 = array[1..3,MBegin..NY,MBegin..NZ1] of FloatType;
     tEYX_1 = array[1..3,MBegin..NY1,MBegin..NZ] of FloatType;
     tEZY_1 = array[1..3,MBegin..NX,MBegin..NZ1] of FloatType;
     tEXY_1 = array[1..3,MBegin..NX1,MBegin..NZ]  of FloatType;
     tEYZ_1 = array[1..3,MBegin..NX,MBegin..NY1]  of FloatType;
     tEXZ_1 = array[1..3,MBegin..NX1,MBegin..NY]  of FloatType;
     t3DPoint = record
                X,Y,Z: Integer;
                end;

var
  XSize, YSize, ZSize, PSize : Integer; //   
       // 
   HX  : tHX;
   HY  : tHY;
   HZ  : tHZ;
   EX  : tEX;
   EY  : tEY;
   EZ  : tEZ;
   MaxEArray : tMaxJArray;
   //     
   AE, BE, AH, SIG, EPS : tEXYZ; //   , , AH      E(x,y,z,t)
   //      
   EZX1, EZXN: tEZX;
   EYX1, EYXN: tEYX;
   EZY1, EZYN: tEZY;
   EXY1, EXYN: tEXY;
   EYZ1, EYZN: tEYZ;
   EXZ1, EXZN: tEXZ;
    //  RT-ABC
   EZX1_3, EZXN_3: tEZX_3;
   EYX1_3, EYXN_3: tEYX_3;
   EZY1_3, EZYN_3: tEZY_3;
   EXY1_3, EXYN_3: tEXY_3;
   EYZ1_3, EYZN_3: tEYZ_3;
   EXZ1_3, EXZN_3: tEXZ_3;
   //      
      //    
   EZX1_2, EZXN_2: tEZX_2;
   EYX1_2, EYXN_2: tEYX_2;
   EZY1_2, EZYN_2: tEZY_2;
   EXY1_2, EXYN_2: tEXY_2;
   EYZ1_2, EYZN_2: tEYZ_2;
   EXZ1_2, EXZN_2: tEXZ_2;
      //    
   EZX1_1, EZXN_1: tEZX_1;
   EYX1_1, EYXN_1: tEYX_1;
   EZY1_1, EZYN_1: tEZY_1;
   EXY1_1, EXYN_1: tEXY_1;
   EYZ1_1, EYZN_1: tEYZ_1;
   EXZ1_1, EXZN_1: tEXZ_1;

    TimeDAN, ValueDAN:  tDoubleArray; // -       
//    ApproxDAN:  tDoubleArray; // -       

    CountOfInputValues: Integer; //    ApproxDAN
    SizeOfFloatType: Integer;    //    
    T: FloatType;
    Error: boolean;   // 
    Tx,Ty,Tz: FloatType; //   
    dt,dx,dy,dz: FloatType; //       
    dTcek: FloatType; //     c
    dx2,dy2,dz2: FloatType; //        
    StepCount: Integer;
    Gap1,Gap2,Gap3,Gap4,Gap5,Gap6 : boolean;//   
    RT1,RT2,RT3,RT4,RT5,RT6: boolean;//   RT-ABC
    Absorp1,Absorp2,Absorp3,Absorp4,Absorp5,Absorp6: boolean;//    1 
    Absorp1_2,Absorp2_2,Absorp3_2,Absorp4_2,Absorp5_2,Absorp6_2: boolean;//    2 
    Dissip1,Dissip2,Dissip3,Dissip4,Dissip5,Dissip6: boolean;//   
    Simmetry1,Simmetry2,Simmetry3,Simmetry4: boolean;//  
    X,Y,Z,XX,YY,ZZ,TT: FloatType;//  
    ValueCount: Integer;
    IO, JO, KO: Integer; // .  
    R1,R2: FloatType; //     
    K1,K2,K3,K4: FloatType; //    
    Expression: Boolean; //   
    InputFile:Boolean; //     
    NoInput:Boolean; //   
    ExpressNo: Integer; //  
    A, F, A1, A2 : FloatType; //    
    tzo,Tw : FloatType; //    
    FileOutput: Array[1..50] of TextFile; //    
    FileYes: Array[1..50] of boolean;
    ShowGr: boolean; //      
    ShowInput: boolean; //      
    StartPoint: Integer; //     

    NumNonZeroSels: Integer;// -  
    dV: real; //  
    MaxJ_, MaxSar_,MaxJ, MaxSar, Energy: Real; //     
    ro: Real; // 
    bA,bB,bC,bD,bEnergy: boolean; //  SAR

    //  
//      
Procedure InitZero;
//     H     
Procedure TimeStepForH;
//     E     
Procedure TimeStepForE;
//               
Function  GetInputField(T: FloatType; GetZeroValue: boolean): FloatType;
//               
Function  GetStartPoint(T: FloatType): Integer;
   //  
Procedure AbsorpBordersSpaceLimit;
   //  
Procedure DissipBordersSpaceLimit;
   //  RT-ABC
Procedure RT_ABC;
//     
Procedure BordersGapLimit;
//          AbsorpBordersSpaceLimit;
Procedure GetBorderValues;
//       
Procedure NS_Absorption(var EE: FloatType;EE1,H: FloatType; N,M: integer);
//       
Procedure  NS_Dissipation(var EE,EE1,HH1,HH2,HH3,HH4: FloatType; N: Integer);
//           AbsorpBordersSecondSpaceLimit;
Procedure GetBorderValuesForSecondAprox;
   //   2 
Procedure AbsorpSecondBordersSpaceLimit;
//         
Function NS_AbsorptionSecond(K1,K2,K3,K4,E1,E2,E3,E4,E5,E6,E7,E8,E9,E10,E11,E12,E13,E14,E15,E16,E17: FloatType):FloatType;
//         2 
Procedure NS_AbsorptionFirst(var EE: FloatType;EE1,H: FloatType; N,M: integer);
//    
Procedure BordersSimmetryE;
Procedure BordersSimmetryH;
//  
Procedure CalculateSar(bA,bB,bC,bD,bEnergy: boolean);

implementation
 uses  N3dMain,D3OpenMain;
//      
Procedure InitZero;
  var I,J,K: Integer;
begin
   //  
   for I:=1 to XSize do  for J:=1 to YSize-1 do  for K:=1 to ZSize-1 do  HX[I,J,K]:=0.;
   for I:=1 to XSize-1 do for J:=1 to YSize do    for K:=1 to ZSize-1 do HY[I,J,K]:=0.;
   for I:=1 to XSize-1 do for J:=1 to YSize-1 do   for K:=1 to ZSize do  HZ[I,J,K]:=0.;
   for I:=1 to XSize-1 do for J:=1 to YSize do    for K:=1 to ZSize do  EX[I,J,K]:=0.;
   for I:=1 to XSize do  for J:=1 to YSize-1 do   for K:=1 to ZSize do  EY[I,J,K]:=0.;
   for I:=1 to XSize do  for J:=1 to YSize do    for K:=1 to ZSize-1 do EZ[I,J,K]:=0.;
      //      
   for J:=1 to YSize do for K:=1 to ZSize-1 do  begin EZX1[J,k]:=0;EZXN[J,k]:=0; end;
   for J:=1 to YSize-1 do for K:=1 to ZSize do  begin EYX1[J,k]:=0;EYXN[J,k]:=0; end;
   for I:=1 to XSize do for K:=1 to ZSize-1 do  begin EZY1[I,k]:=0;EZYN[I,k]:=0; end;
   for I:=1 to XSize-1 do for K:=1 to ZSize do  begin EXY1[I,k]:=0;EXYN[I,k]:=0; end;
   for I:=1 to XSize do for J:=1 to YSize-1 do  begin EYZ1[I,J]:=0;EYZN[I,J]:=0; end;
   for I:=1 to XSize-1 do for J:=1 to YSize do  begin EXZ1[I,J]:=0;EXZN[I,J]:=0; end;
      //      
            //    
   for I:=2 to 2 do for J:=1 to YSize do for K:=1 to ZSize-1 do begin EZX1_3[I,J,k]:=0; EZXN_3[I,J,k]:=0; end;
   for I:=2 to 2 do for J:=1 to YSize-1 do for K:=1 to ZSize do begin EYX1_3[I,J,k]:=0; EYXN_3[I,J,k]:=0; end;
   for I:=2 to 2 do for J:=1 to XSize do for K:=1 to ZSize-1 do begin EZY1_3[I,J,k]:=0; EZYN_3[I,J,k]:=0; end;
   for I:=2 to 2 do for J:=1 to XSize-1 do for K:=1 to ZSize do begin EXY1_3[I,J,k]:=0; EXYN_3[I,J,k]:=0; end;
   for I:=2 to 2 do for J:=1 to XSize do for K:=1 to YSize-1 do begin EYZ1_3[I,J,k]:=0; EYZN_3[I,J,k]:=0; end;
   for I:=2 to 2 do for J:=1 to XSize-1 do for K:=1 to YSize do begin EXZ1_3[I,J,k]:=0; EXZN_3[I,J,k]:=0; end;
            //    
   for I:=1 to 3 do for J:=1 to YSize do for K:=1 to ZSize-1 do begin EZX1_2[I,J,k]:=0; EZXN_2[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to YSize-1 do for K:=1 to ZSize do begin EYX1_2[I,J,k]:=0; EYXN_2[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize do for K:=1 to ZSize-1 do begin EZY1_2[I,J,k]:=0; EZYN_2[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize-1 do for K:=1 to ZSize do begin EXY1_2[I,J,k]:=0; EXYN_2[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize do for K:=1 to YSize-1 do begin EYZ1_2[I,J,k]:=0; EYZN_2[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize-1 do for K:=1 to YSize do begin EXZ1_2[I,J,k]:=0; EXZN_2[I,J,k]:=0; end;
            //    
   for I:=1 to 3 do for J:=1 to YSize do for K:=1 to ZSize-1 do begin EZX1_1[I,J,k]:=0; EZXN_1[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to YSize-1 do for K:=1 to ZSize do begin EYX1_1[I,J,k]:=0; EYXN_1[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize do for K:=1 to ZSize-1 do begin EZY1_1[I,J,k]:=0; EZYN_1[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize-1 do for K:=1 to ZSize do begin EXY1_1[I,J,k]:=0; EXYN_1[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize do for K:=1 to YSize-1 do begin EYZ1_1[I,J,k]:=0; EYZN_1[I,J,k]:=0; end;
   for I:=1 to 3 do for J:=1 to XSize-1 do for K:=1 to YSize do begin EXZ1_1[I,J,k]:=0; EXZN_1[I,J,k]:=0; end;

// 

   //        Sig, Eps, AH ()
  For I:= 1 to XSize      do
      For j:= 1 to YSize    do
         For k:= 1 to ZSize   do
            begin
            Sig[i,j,k]:=SIGW;
            Eps[i,j,k]:=EPSW;
            AH[i,j,k]:=1/MU;//DT/(DX*MU);
            end;
end;
//========================================================================
//                        H
//========================================================================
Procedure TimeStepForH;
  var I,J,K: Integer;
begin
      For I:=1 to XSize do
         for J:=1 to YSize-1 do
            for K:=1 to ZSize-1 do
         HX[I,J,K]:=HX[I,J,K]-((EZ[I,J+1,K]-EZ[I,J,K])*TY-(EY[I,J,K+1]-EY[I,J,K])*TZ)*AH[I,J,K];

      For I:=1 to XSize-1 do
         for J:=1 to YSize do
            for K:=1 to ZSize-1 do
          HY[I,J,K]:=HY[I,J,K]-((EX[I,J,K+1]-EX[I,J,K])*TZ-(EZ[I+1,J,K]-EZ[I,J,K])*TX)*AH[I,J,K];

      For I:=1 to XSize-1 do
         for J:=1 to YSize-1 do
            for K:=1 to ZSize do
          HZ[I,J,K]:=HZ[I,J,K]-((EY[I+1,J,K]-EY[I,J,K])*TX-(EX[I,J+1,K]-EX[I,J,K])*TY)*AH[I,J,K];

end;//     H

//========================================================================
//     E
//========================================================================
Procedure TimeStepForE;
  var I,J,K: Integer;
begin
   for I:=1 to XSize-1 do
      begin
      for J:=2 to YSize-1 do
        begin
        for K:=2 to ZSize-1 do
          begin
          EX[I,J,K]:=EX[I,J,K]*AE[I,J,K]+((HZ[I,J,K]-HZ[I,J-1,K])*TY-
                                          (HY[I,J,K]-HY[I,J,K-1])*TZ)*BE[I,J,K];

         end;
        end;
      end;

  for I:=2 to XSize-1 do
      for J:=1 to YSize-1 do
        for K:=2 to ZSize-1 do begin

//       if not( (I=30)and(J=30)and(K=30) )then

          EY[I,J,K]:=EY[I,J,K]*AE[I,J,K]+((HX[I,J,K]-HX[I,J,K-1])*TZ-
                                        (HZ[I,J,K]-HZ[I-1,J,K])*TX)*BE[I,J,K]

{          else EY[I,J,K]:=EY[I,J,K]+
               ((HX[I,J,K]-HX[I,J,K-1])*TZ-
                (HZ[I,J,K]-HZ[I-1,J,K])*TX)

          *dX*dZ/(100e-12*C*dY+Epsw*dX*dZ);
 }
      end;

   for I:=2 to XSize-1 do
      for J:=2 to YSize-1 do
        for K:=1 to ZSize-1 do begin
        EZ[I,J,K]:=EZ[I,J,K]*AE[I,J,K]+((HY[I,J,K]-HY[I-1,J,K])*TX-
                                        (HX[I,J,K]-HX[I,J-1,K])*TY)*BE[I,J,K];
      END;
end;//     E

Function  GetStartPoint(T: FloatType): Integer;
  var J: Integer;
begin
  Result:=0;
 if InputFile then begin
  if T> TimeDAN[ValueCount-1] then exit;
  if T<= TimeDAN[0] then exit;
  for J:=StartPoint to  ValueCount-1 do begin
          if (T < TimeDAN[J])and((T >= TimeDAN[J-1])) then
                       begin
                       Result:=J-1;
                       if result<1 then result:=1;
                       break;
                       end;
    end;
  end;  //if not Expression then begin
end;
//               
Function  GetInputField(T: FloatType; GetZeroValue: boolean): FloatType;
  var J: Integer;
begin
//========================================================================C
  Result:=0;
  if  GetZeroValue then Exit;
  if T<=0 then exit;
  if InputFile then begin
    if T> TimeDAN[ValueCount-1] then exit;
    if T < TimeDAN[0] then exit;
    for J:=StartPoint to  ValueCount-1 do begin
          if (T < TimeDAN[J])and(T >= TimeDAN[J-1]) then
                       begin
                       Result:=(ValueDAN[J]*(T-TimeDAN[J-1])+(TimeDAN[J]-T)*ValueDAN[J-1])
                               /(TimeDAN[J]-TimeDAN[J-1]);
                       break;
                       end;
    end;
  end;  //if InputFile then begin

  if Expression then begin
    if ExpressNo = 0 then begin //A*Sin(2 * Pi * f * t)

         if T>0 then
              Result:=A*Sin(2 * Pi * F * T/C);
         end; //ExpressNo = 0
    if ExpressNo = 1 then begin //A*(EXP(-a1 * t) - EXP(-a2 * t))
         if T>0 then
              Result:=A*(EXP(-A1 * T/C) - EXP(-A2 * T/C));
         end; //ExpressNo = 1
    if ExpressNo = 2 then begin //A*(EXP(-sqr(t - tzo)/Tw))
         if T>0 then
              Result:=A*(EXP( -sqr( (T-tzo) / Tw) ) );
         end; //ExpressNo = 1

  end; //if Expression then begin
end;
//     
Procedure BordersGapLimit;
  var I,J,K: Integer;
begin
  //     
  if Gap1 then
     begin
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do   EX[I,1,K]:=0;
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do     EZ[I,1,K]:=0;
     end;//if Gap1
  //      
  if Gap2 then
     begin
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do   EX[I,YSize,K]:=0;
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do     EZ[I,YSize,K]:=0;
     end;//if Gap2

  //       (    )
  if Gap3 then
     begin
         For J:=1 to YSize do
            For I:=1 to XSize-1 do   EX[I,J,ZSize]:=0;
         For J:=1 to YSize-1 do
            For I:=1 to XSize do   EY[I,J,ZSize]:=0;
     end;//if Gap3

  //       (    )
  if Gap4 then
     begin
         For J:=1 to YSize do
            For I:=1 to XSize-1 do   EX[I,J,1]:=0;
         For J:=1 to YSize-1 do
            For I:=1 to XSize do   EY[I,J,1]:=0;
     end;//if Gap4

  //       (    )
  if Gap5 then
     begin
         For J:=1 to YSize do
            For K:=1 to ZSize-1 do   EZ[XSize,J,K]:=0;
         For J:=1 to YSize-1 do
            For K:=1 to ZSize do   EY[XSize,J,K]:=0;
     end;//if Gap5
  //       (    )
  if Gap6 then
     begin
         For J:=1 to YSize do
            For K:=1 to ZSize-1 do   EZ[1,J,K]:=0;
         For J:=1 to YSize-1 do
            For K:=1 to ZSize do   EY[1,J,K]:=0;
     end;//if Gap6

end;

//          AbsorpBordersSpaceLimit
Procedure GetBorderValues;
  var I,J,K: Integer;
begin
     //   
  if (Absorp6)or(Absorp5) then begin
      for J:=1 to YSize do for k:=1 to ZSize-1 do
          begin
           if (Absorp6) then EZX1[J,K]:=EZ[2,J,K];
           if (Absorp5) then EZXN[J,K]:=EZ[XSize-1,J,K];
          end;

      for J:=1 to YSize-1 do for k:=1 to ZSize do
          begin
           if (Absorp6) then EYX1[J,K]:=EY[2,J,K]-GetInputField(T-dT-dX,NoInput);
           if (Absorp5) then EYXN[J,K]:=EY[XSize-1,J,K]-GetInputField(T-dT-(XSize-2)*dX,NoInput);
          end;
      end;
     //   
  if (Absorp2)or(Absorp1) then begin
      for I:=1 to XSize do for k:=1 to ZSize-1 do
          begin
           if (Absorp1) then EZY1[I,K]:=EZ[I,2,K];
           if (Absorp2) then EZYN[I,K]:=EZ[I,YSize-1,K];
          end;

      for I:=1 to XSize-1 do for k:=1 to ZSize do
          begin
           if (Absorp1) then EXY1[I,K]:=EX[I,2,K];
           if (Absorp2) then EXYN[I,K]:=EX[I,YSize-1,K];
          end;
      end;
     //   
  if (Absorp3)or(Absorp4) then begin
      for I:=1 to XSize do for J:=1 to YSize-1 do
          begin
//           if (Absorp4) then EYZ1[I,J]:=EY[I,J,2];
//           if (Absorp3) then EYZN[I,J]:=EY[I,J,ZSize-1];
           if (Absorp4) then EYZ1[I,J]:=EY[I,J,2]-GetInputField(T-dT-(I-1)*dX,NoInput);
           if (Absorp3) then EYZN[I,J]:=EY[I,J,ZSize-1]-GetInputField(T-dT-(I-1)*dX,NoInput);
          end;

      for I:=1 to XSize-1 do for J:=1 to YSize do
          begin
           if (Absorp4) then EXZ1[I,J]:=EX[I,J,2];
           if (Absorp3) then EXZN[I,J]:=EX[I,J,ZSize-1];
          end;
      end;
end;

//  
   //  
Procedure AbsorpBordersSpaceLimit;
  var I,J,K: Integer;
begin
   //      .
   //     -   
  //   
 // Ez    YxZ (  )
  if (Absorp5)or(Absorp6) then
      for J:=2 to YSize-1 do
      for K:=1 to ZSize-1 do begin
//      X:=DX;
//      XX:=0.0;
      if (Absorp6) then
                //NS_Absorption (EZ[1,J,K],EZ[2,J,K],EZX1[J,K],3,1);
                EZ[1,J,K]:=EZX1[J,K]+(Tx-1)/(Tx+1)*(EZ[2,J,K]-EZ[1,J,K]);
//      X:=(XSize-1-1)*DX;
//      XX:=X+DX;
      if (Absorp5) then
            //NS_Absorption (EZ[XSize,J,K],EZ[XSize-1,J,K],EZXN[J,K],3,1);
                EZ[XSize,J,K]:=EZXN[J,K]+(Tx-1)/(Tx+1)*(EZ[XSize-1,J,K]-EZ[XSize,J,K]);
      end;

 // Ey    YxZ [  ]
  if (Absorp5)or(Absorp6) then
      for J:=1 to YSize-1 do
      for K:=2 to ZSize-1 do begin
//      X:=DX;
//      XX:=0.;
      if (Absorp6) then
             //NS_Absorption (EY[1,J,K],EY[2,J,K],EYX1[J,K],2,1);
             EY[1,J,K]:=EYX1[J,K]+(Tx-1)/(Tx+1)*
              (EY[2,J,K]-GetInputField(T-dX,NoInput)-EY[1,J,K]+GetInputField(T-dT,NoInput))+GetInputField(T,NoInput);;
//      X:=(XSize-1-1)*DX;
//      XX:=X+DX;
      if (Absorp5) then
             //NS_Absorption (EY[XSize,J,K],EY[XSize-1,J,K],EYXN[J,K],2,1);
             EY[XSize,J,K]:=EYXN[J,K]+(Tx-1)/(Tx+1)*
             (EY[XSize-1,J,K]-GetInputField(T-(XSize-2)*DX,NoInput)-EY[XSize,J,K]+
             GetInputField(T-(XSize-1)*DX-dT,NoInput))+
             GetInputField(T-(XSize-1)*DX,NoInput);
      end;

  //   
 // Ex    XxZ [  ]
  if (Absorp1)or(Absorp2) then
      for K:=2 to ZSize-1 do
      for I:=1 to XSize-1 do begin
//      X:=(I-0.5)*DX;
//      XX:=X;
      if (Absorp1) then
             //NS_Absorption (EX[I,1,K],EX[I,2,K],EXY1[I,K],1,2);
             EX[I,1,K]:=  EXY1[I,K]+(Ty-1)/(Ty+1)*(EX[I,2,K]-EX[I,1,K]);
      if (Absorp2) then
             //NS_Absorption (EX[I,YSize,K],EX[I,YSize-1,K],EXYN[I,K],1,2);
             EX[I,YSize,K]:=  EXYN[I,K]+(Ty-1)/(Ty+1)*(EX[I,YSize-1,K]-EX[I,YSize,K]);
      end;

 // Ez    XxZ [  ]
  if (Absorp1)or(Absorp2) then
      for K:=1 to ZSize-1 do
      for I:=2 to XSize-1 do begin
//      X:=(I-1)*DX;
//      XX:=X;
      if (Absorp1) then
             //NS_Absorption (EZ[I,1,K],EZ[I,2,K],EZY1[I,K],3,2);
             EZ[I,1,K]:=  EZY1[I,K]+(Ty-1)/(Ty+1)*(EZ[I,2,K]-EZ[I,1,K]);
      if (Absorp2) then
             //NS_Absorption (EZ[I,YSize,K],EZ[I,YSize-1,K],EZYN[I,K],3,2);
             EZ[I,YSize,K]:=  EZYN[I,K]+(Ty-1)/(Ty+1)*(EZ[I,YSize-1,K]-EZ[I,YSize,K]);
      end;

  //   
 // Ey    XxY [  ]
  if (Absorp3)or(Absorp4) then
      for I:=2 to XSize-1 do
      for J:=1 to YSize-1 do begin
//      X:=DX*(I-1);
//      XX:=X;
      if (Absorp3) then
              //NS_Absorption (EY[I,J,ZSize],EY[I,J,ZSize-1],EYZN[I,J],2,3);
              EY[I,J,ZSize]:=EYZN[I,J]+(Tz-1)/(Tz+1)*(EY[I,J,ZSize-1]-GetInputField(T-(I-1)*DX,NoInput)-EY[I,J,ZSize]+GetInputField(T-(I-1)*DX-dT,NoInput))
                  +GetInputField(T-(I-1)*DX,NoInput);
      if (Absorp4) then
              //NS_Absorption (EY[I,J,1],EY[I,J,2],EYZ1[I,J],2,3);
              EY[I,J,1]:=EYZ1[I,J]+(Tz-1)/(Tz+1)*(EY[I,J,2]-GetInputField(T-(I-1)*DX,NoInput)-EY[I,J,1]+GetInputField(T-(I-1)*DX-dT,NoInput))
                  +GetInputField(T-(I-1)*DX,NoInput);
      end;

 // Ex    XxY [  ]
  if (Absorp3)or(Absorp4) then
      for I:=1 to XSize-1 do
      for J:=2 to YSize-1 do begin
//      X:=DX*(I-0.5);
//      XX:=X;
      if (Absorp3) then
              //NS_Absorption (EX[I,J,ZSize],EX[I,J,ZSize-1],EXZN[I,J],1,3);
            EX[I,J,ZSize]:=  EXZN[I,J]+(Tz-1)/(Tz+1)*(EX[I,J,ZSize-1]-EX[I,J,ZSize]);
      if (Absorp4) then
              //NS_Absorption (EX[I,J,1],EX[I,J,2],EXZ1[I,J],1,3);
            EX[I,J,1]:=  EXZ1[I,J]+(Tz-1)/(Tz+1)*(EX[I,J,2]-EX[I,J,1]);
      end;

// ,   Z
  if (Absorp6)or(Absorp5) then
      for K:=1 to ZSize-1 do begin
//      X:=DX;
//      XX:=0.;
      if Absorp6 then
                //NS_Absorption (EZ[1,1,K],EZ[2,1,K],EZX1[1,K],3,1);
                EZ[1,1,K]:=EZX1[1,K]+(Tx-1)/(Tx+1)*(EZ[2,1,K]-EZ[1,1,K]);
      if Absorp6 then
                //NS_Absorption (EZ[1,YSize,K],EZ[2,YSize,K],EZX1[YSize,K],3,1);
                EZ[1,YSize,K]:=EZX1[YSize,K]+(Tx-1)/(Tx+1)*(EZ[2,YSize,K]-EZ[1,YSize,K]);
//      X:=(XSize-1-1)*DX;
//      XX:=X+DX;
      if Absorp5 then
                  //NS_Absorption (EZ[XSize,1,K],EZ[XSize-1,1,K],EZXN[1,K],3,1);
                  EZ[XSize,1,K]:=EZXN[1,K]+(Tx-1)/(Tx+1)*(EZ[XSize-1,1,K]-EZ[XSize,1,K]);
      if Absorp5 then
                  //NS_Absorption (EZ[XSize,YSize,K],EZ[XSize-1,YSize,K],EZXN[YSize,K],3,1);
                  EZ[XSize,YSize,K]:=EZXN[YSize,K]+(Tx-1)/(Tx+1)*(EZ[XSize-1,YSize,K]-EZ[XSize,YSize,K]);
      end;

// ,   Y
  if (Absorp6)or(Absorp5) then
      for J:=1 to YSize-1 do begin
//      X:=DX;
//      XX:=0.;
      if Absorp6 then
               //NS_Absorption (EY[1,J,1],EY[2,J,1],EYX1[J,1],2,1);
               EY[1,J,1]:=EYX1[J,1]+(Tx-1)/(Tx+1)*(EY[2,J,1]-GetInputField(T-dX,NoInput)-EY[1,J,1]+GetInputField(T-dT,NoInput))+GetInputField(T,NoInput);
      if Absorp6 then
               //NS_Absorption (EY[1,J,ZSize],EY[2,J,ZSize],EYX1[J,ZSize],2,1);
               EY[1,J,ZSize]:=EYX1[J,ZSize]+(Tx-1)/(Tx+1)*(EY[2,J,ZSize]-GetInputField(T-dX,NoInput)-EY[1,J,ZSize]+GetInputField(T-dT,NoInput))+GetInputField(T,NoInput);
//      X:=(XSize-1-1)*DX;
//      XX:=X+DX;
      if Absorp5 then
                //NS_Absorption (EY[XSize,J,1],EY[XSize-1,J,1],EYXN[J,1],2,1);
                EY[XSize,J,1]:=EYXN[J,1]+(Tx-1)/(Tx+1)*(EY[XSize-1,J,1]-GetInputField(T-(XSize-2)*DX,NoInput)-EY[XSize,J,1]+GetInputField(T-(XSize-1)*DX-dT,NoInput))+GetInputField(T-(XSize-1)*DX,NoInput);
      if Absorp5 then
                //NS_Absorption (EY[XSize,J,ZSize],EY[XSize-1,J,ZSize],EYXN[J,ZSize],2,1);
                EY[XSize,J,ZSize]:=EYXN[J,ZSize]+(Tx-1)/(Tx+1)*(EY[XSize-1,J,ZSize]-GetInputField(T-(XSize-2)*DX,NoInput)-EY[XSize,J,ZSize]+GetInputField(T-(XSize-1)*DX-dT,NoInput))+GetInputField(T-(XSize-1)*DX,NoInput);
      end;

// ,   X
  if (Absorp1)or(Absorp2) then
      for I:=1 to XSize-1 do begin
      X:=(I-0.5)*DX;
      XX:=X;
      if Absorp1 then
                 //NS_Absorption (EX[I,1,1],EX[I,2,1],EXY1[I,1],1,2);
                  EX[I,1,1]:=EXY1[I,1]+ (Ty-1)/(Ty+1)*(EX[I,2,1]-EX[I,1,1]);
      if Absorp1 then
                 //NS_Absorption (EX[I,1,ZSize],EX[I,2,ZSize],EXYN[I,ZSize],1,2);
                  EX[I,1,ZSize]:=EXYN[I,ZSize]+(Ty-1)/(Ty+1)*(EX[I,2,ZSize]-EX[I,1,ZSize]);
      if Absorp2 then
                 //NS_Absorption (EX[I,YSize,1],EX[I,YSize-1,1],EXY1[I,1],1,2);
                 EX[I,YSize,1]:=EXY1[I,1]+(Ty-1)/(Ty+1)*(EX[I,YSize-1,1]-EX[I,YSize,1]);
      if Absorp2 then
                 //NS_Absorption (EX[I,YSize,ZSize],EX[I,YSize-1,ZSize],EXYN[I,ZSize],1,2);
                 EX[I,YSize,ZSize]:=EXYN[I,ZSize]+(Ty-1)/(Ty+1)*(EX[I,YSize-1,ZSize]-EX[I,YSize,ZSize]);
      end;
end;
//     
Procedure NS_Absorption(var EE: FloatType;EE1,H: FloatType; N,M: integer);
  var E,E1,H1: FloatType;

  function FY(X,T: FloatType): FloatType;
  begin
   result:=GetInputField(T-X,NoInput);
  end;

begin
      E:=0;E1:=0;H1:=0;
      TT:=T-DT;
      case N of
           1:    begin   //Ex
                 E:=EE;
                 E1:=EE1;
                 H1:=H;
                 end;
           2:    begin   //Ey
                 E:=EE-FY(Xx,TT);
                 E1:=EE1-FY(x,T);
                 H1:=H-FY(x,TT);
                 end;
           3:    begin   //Ez
                 E:=EE;
                 E1:=EE1;
                 H1:=H;
                 end;
            end;

      case M of
           1:   E:=H1+(TX-1)/(TX+1)*(E1-E);
           2:   E:=H1+(TY-1)/(TY+1)*(E1-E);
           3:   E:=H1+(TZ-1)/(TZ+1)*(E1-E);
           end;

      case N of
          1:    EE:=E;
          2:    EE:=E+FY(Xx,T);
          3:    EE:=E;
          end;
end;
   //  
Procedure DissipBordersSpaceLimit;
 var I,J,K: Integer;
     R: double;
begin
//Ez  Ey   
 if Dissip6 or Dissip5 then begin
  For J:=2 to YSize-1 do
    for K:=1 to ZSize-1 do begin
      R:= SQR((J-JO)*DY)+SQR((K+0.5-KO)*DZ);

//....................Ez    
      if Dissip6 then begin
        R1:=SQRT(SQR((IO-1)*DX)+R);
        R2:=SQRT(SQR((IO-2)*DX)+R);
        X:=DX;
        XX:=0;
    {  Y=(J-1)*DY
      YY=Y
      Z=(K-1.5)*DZ
      ZZ=Z}
        NS_Dissipation (EZ[1,J,K],EZ[2,J,K],HY[2,J,K],HY[1,J,K],HX[2,J,K],HX[2,J-1,K],3);
        end;

//....................Ez    
      if Dissip5 then begin
        R1:=SQRT(SQR((XSize-IO)*DX)+R);
        R2:=SQRT(SQR((XSize-1-IO)*DX)+R);
        X:=(XSize-1-1)*DX;
        XX:=X+DX;
        NS_Dissipation (EZ[XSize,J,K],EZ[XSize-1,J,K],HY[XSize-1,J,K],HY[XSize-1-1,J,K],
                                                  HX[XSize-1,J,K],HX[XSize-1,J-1,K],3);
        end;
      end;

      For J:=1 to YSize-1 do
         for K:=2 to ZSize-1 do begin
      R:=sqr((J+0.5-JO)*DY)+sqr((K-KO)*DZ);

//....................Ey     .....................C
      if Dissip6 then begin
        R1:=SQRT(sqr((IO-1)*DX)+R);
        R2:=SQRT(sqr((IO-2)*DX)+R);
        X:=DX;
        XX:=0.;
        NS_Dissipation (EY[1,J,K],EY[2,J,K],HX[2,J,K],HX[2,J,K-1], HZ[2,J,K],HZ[1,J,K],2);
        end;
//....................Ey     ....................C
      if Dissip5 then begin
        R1:=SQRT(sqr((XSize-IO)*DX)+R);
        R2:=SQRT(sqr((XSize-1-IO)*DX)+R);
        X:=(XSize-1-1)*DX;
        XX:=X+DX;
        NS_Dissipation (EY[XSize,J,K],EY[XSize-1,J,K],HX[XSize-1,J,K],HX[XSize-1,J,K-1], HZ[XSize-1,J,K],HZ[XSize-1-1,J,K],2);
        end;
     end;
  end;   //Ez  Ey   

//Ex  Ey      
 if Dissip3 or Dissip4 then begin
    For I:=2 to XSize-1 do
      for J:=1 to YSize-1 do begin
      R:=SQR((I-IO)*DX)+SQR((J+0.5-JO)*DY);
      X:=DX*(I-1);
      XX:=X;

//....................Ey    () 
      if Dissip3 then begin
        R1:=SQRT(SQR((ZSize-KO)*DZ)+R);
        R2:=SQRT(SQR((ZSize-1-KO)*DZ)+R);
        NS_Dissipation (EY[I,J,ZSize],EY[I,J,ZSize-1],HX[I,J,ZSize-1],HX[I,J,ZSize-1-1], HZ[I,J,ZSize-1],HZ[I-1,J,ZSize-1],2);
        end;

//....................Ey    
      if Dissip4 then begin
        R1:=SQRT(SQR((1-KO)*DZ)+R);
        R2:=SQRT(SQR((2-KO)*DZ)+R);
        NS_Dissipation (EY[I,J,1],EY[I,J,2],HX[I,J,2],HX[I,J,1],HZ[I,J,2], HZ[I-1,J,2],2);
        end;
      end;

   For I:=1 to XSize-1 do
      for J:=2 to YSize-1 do begin
      R:=SQR((I+0.5-IO)*DX)+SQR((J-JO)*DY);
      X:=DX*(I-0.5);
      XX:=X;
//....................Ex   
      if Dissip3 then begin
        R1:=SQRT(SQR((ZSize-KO)*DZ)+R);
        R2:=SQRT(SQR((ZSize-1-KO)*DZ)+R);
        NS_Dissipation  (EX[I,J,ZSize],EX[I,J,ZSize-1],HZ[I,J,ZSize-1],HZ[I,J-1,ZSize-1],HY[I,J,ZSize-1],HY[I,J,ZSize-1-1],1);
        end;
//....................Ex   
      if Dissip4 then begin
        R1:=SQRT(SQR((1-KO)*DZ)+R);
        R2:=SQRT(SQR((2-KO)*DZ)+R);
        NS_Dissipation (EX[I,J,1],EX[I,J,2],HZ[I,J,2],HZ[I,J-1,2],HY[I,J,2],HY[I,J,1],1);
        end;
      end;
   end;//Ex  Ey      

//Ez  Ex       
 if Dissip1 or Dissip2 then begin
    For K:=2 to ZSize-1 do
      for I:=1 to XSize-1 do begin
      R:=sqr((K-KO)*DZ)+sqr((I+0.5-IO)*DX);
      X:=(I-0.5)*DX;
      XX:=X;
//....................Ex     
      if Dissip1  then begin
         R1:=SQRT(SQR((JO-1)*DY)+R);
         R2:=SQRT(SQR((JO-2)*DY)+R);
         NS_Dissipation(EX[I,1,K],EX[I,2,K],HZ[I,2,K],HZ[I,1,K],HY[I,2,K],HY[I,2,K-1],1);
         end;
//....................Ex     
      if Dissip2  then begin
         R1:=SQRT(SQR((YSize-JO)*DY)+R);
         R2:=SQRT(SQR((YSize-1-JO)*DY)+R);
         NS_Dissipation(EX[I,YSize,K],EX[I,YSize-1,K],HZ[I,YSize-1,K],HZ[I,YSize-1-1,K], HY[I,YSize-1,K],HY[I,YSize-1,K-1],1);
         end;
      end;

    For K:=1 to ZSize-1 do
      for I:=2 to XSize-1 do begin
      R:=SQR((K+0.5-KO)*DZ)+SQR((I-IO)*DX);
      X:=(I-1)*DX;
      XX:=X;

//..................Ez     
      if Dissip1  then begin
         R1:=SQRT(SQR((1-JO)*DY)+R);
         R2:=SQRT(SQR((2-JO)*DY)+R);
         NS_Dissipation(EZ[I,1,K],EZ[I,2,K],HY[I,2,K],HY[I-1,2,K],HX[I,2,K],HX[I,1,K],3);
         end;
//..................Ez     
      if Dissip2  then begin
         R1:=SQRT(SQR((YSize-JO)*DY)+R);
         R2:=SQRT(SQR((YSize-1-JO)*DY)+R);
         NS_Dissipation(EZ[I,YSize,K],EZ[I,YSize-1,K],HY[I,YSize-1,K],HY[I-1,YSize-1,K],  HX[I,YSize-1,K],HX[I,YSize-1-1,K],3);
         end;
      end;

 end;//Ez  Ex       

//........................  1/R
//
//   
      if  Dissip6  then begin
           //     
          X:=DX;
          XX:=0.;
          for k:=1 to ZSize-1 do begin
               R:=SQR((K+0.5-KO)*DZ);
               //   ,|| Z
               R1:=SQRT(SQR((IO-1)*DX)+SQR((JO-1)*DY)+R);
               R2:=SQRT(SQR((IO-2)*DX)+SQR((JO-2)*DY)+R);
               NS_Dissipation(EZ[1,1,K],EZ[2,2,K],HY[2,2,K],HY[1,2,K],HX[2,2,K],HX[2,1,K],3);
               //   ,|| Z
               R1:=SQRT(SQR((IO-1)*DX)+SQR((JO-YSize)*DY)+R);
               R2:=SQRT(SQR((IO-2)*DX)+SQR((JO-YSize-1)*DY)+R);
               NS_Dissipation(EZ[1,YSize,K],EZ[2,YSize-1,K],HY[2,YSize-1,K],HY[1,YSize-1,K],HX[2,YSize-1,K], HX[2,YSize-1-1,K],3);
               end;
           //     
          X:=DX;         //  $
          XX:=X-DX;      //  $
          for J:=1 to YSize-1 do begin
               R:=SQR((J+0.5-JO)*DY);
               //   ,|| Y
               R1:=SQRT(SQR((ZSize-KO)*DZ)+SQR((IO-1)*DX)+R);
               R2:=SQRT(SQR((ZSize-1-KO)*DZ)+SQR((IO-2)*DX)+R);
               NS_Dissipation(EY[1,J,ZSize],EY[2,J,ZSize-1],HX[2,J,ZSize-1],HX[2,J,ZSize-1-1],HZ[2,J,ZSize-1],HZ[1,J,ZSize-1],2);
               //   ,|| Y
               R1:=SQRT(SQR((KO-1)*DZ)+SQR((IO-1)*DX)+R);
               R2:=SQRT(SQR((KO-2)*DZ)+SQR((IO-2)*DX)+R);
               NS_Dissipation(EY[1,J,1],EY[2,J,2],HX[2,J,2],HX[2,J,1],HZ[2,J,2],HZ[1,J,2],2);
               end;
          end; //if  Dissip6  then begin

//   
      if  Dissip5  then begin
           //     
        X:=DX*(XSize-1-1);
        XX:=DX+X;
          for k:=1 to ZSize-1 do begin
               R:=SQR((K+0.5-KO)*DZ);
               //   ,|| Z
               R1:=SQRT(SQR((XSize-IO)*DX)+SQR((1 -JO)*DY)+R);
               R2:=SQRT(SQR((XSize-1-IO)*DX)+SQR((JO-2)*DY)+R);
               NS_Dissipation(EZ[XSize,1,K],EZ[XSize-1,2,K],HY[XSize-1,2,K],HY[XSize-1-1,2,K],HX[XSize-1,2,K],HX[XSize-1,1,K],3);
               //   ,|| Z
               R1:=SQRT(SQR((XSize-IO)*DX)+SQR((YSize-JO)*DY)+R);
               R2:=SQRT(SQR((XSize-1-IO)*DX)+SQR((YSize-1-JO)*DY)+R);
               NS_Dissipation(EZ[XSize,YSize,K],EZ[XSize-1,YSize-1,K],HY[XSize-1,YSize-1,K],HY[XSize-1-1,YSize-1,K],HX[XSize-1,YSize-1,K],HX[XSize-1,YSize-1-1,K],3);
               end;
           //     
          for J:=1 to YSize-1 do begin
               R:=SQR((J+0.5-JO)*DY);
               //   ,|| Y
               R1:=SQRT(SQR((ZSize-KO)*DZ)+SQR((XSize-IO)*DX));
               R2:=SQRT(SQR((ZSize-1-KO)*DZ)+SQR((XSize-1-IO)*DX));
               NS_Dissipation(EY[XSize,J,ZSize],EY[XSize-1,J,ZSize-1],HX[XSize-1,J,ZSize-1],HX[XSize-1,J,ZSize-1-1],HZ[XSize-1,J,ZSize-1],HZ[XSize-1-1,J,ZSize-1],2);
               //   ,|| Y
               R1:=SQRT(SQR((KO-1)*DZ)+SQR((XSize-IO)*DX)+R);
               R2:=SQRT(SQR((KO-2)*DZ)+SQR((XSize-1-IO)*DX)+R);
               NS_Dissipation(EY[XSize,J,1],EY[XSize-1,J,2],HX[XSize-1,J,2],HX[XSize-1,J,1],HZ[XSize-1,J,2],HZ[XSize-1-1,J,2],2);
               end;
          end; //if  Dissip6  then begin

// ,   X
    //   
  if Dissip1 then
      for I:=1 to XSize-1 do begin
      X:=(I-0.5)*DX;
      XX:=X;
      R:=SQR((I+0.5-IO)*DX);
      //  
      R1:=SQRT(SQR((1-JO)*DY)+SQR((ZSize-KO)*DZ)+R);
      R2:=SQRT(SQR((2-JO)*DY)+SQR((ZSize-1-KO)*DZ)+R);
      NS_Dissipation(EX[I,1,ZSize],EX[I,2,ZSize-1],HZ[I,2,ZSize-1],HZ[I,1,ZSize-1],HY[I,2,ZSize-1],HY[I,2,ZSize-1-1],1);
      //  
      R1:=SQRT(SQR((JO-1)*DY)+SQR((KO-1)*DZ)+R);
      R2:=SQRT(SQR((JO-2)*DY)+SQR((KO-2)*DZ)+R);
      NS_Dissipation(EX[I,1,1],EX[I,2,2],HZ[I,2,2],HZ[I,1,2],HY[I,2,2],HY[I,2,1],1);
      end;
    //   
  if Dissip2 then
      for I:=1 to XSize-1 do begin
      X:=(I-0.5)*DX;
      XX:=X;
      R:=SQR((I+0.5-IO)*DX);
      //  
      R1:=SQRT(SQR((YSize-JO)*DY)+SQR((ZSize-KO)*DZ)+R);
      R2:=SQRT(SQR((YSize-1-JO)*DY)+((ZSize-1-KO)*DZ)+R);
      NS_Dissipation(EX[I,YSize,ZSize],EX[I,YSize-1,ZSize-1],HZ[I,YSize-1,ZSize-1],HZ[I,YSize-1-1,ZSize-1],HY[I,YSize-1,ZSize-1],HY[I,YSize-1,ZSize-1-1],1);
      //  
      R1:=SQRT(SQR((YSize-JO)*DY)+SQR((KO-1)*DZ)+R);
      R2:=SQRT(SQR((YSize-1-JO)*DY)+((KO-2)*DZ)+R);
      NS_Dissipation(EX[I,YSize,1],EX[I,YSize-1,2],HZ[I,YSize-1,2],HZ[I,YSize-1-1,2],HY[I,YSize-1,2],HY[I,YSize-1,1],1);
      end;
end;

Procedure  NS_Dissipation(var EE,EE1,HH1,HH2,HH3,HH4: FloatType; N: Integer);
var TT,E,E1,D1,D2,H1,H2,H3,H4  :double;
    R :double;

 function FY(X,T: Double):double;
   begin
     Result:=GetInputField(T-X,NoInput);
   end;
 function FHZ(X,T: Double):double;
   begin
     Result:=GetInputField(T-X,NoInput)/377.;
   end;

begin

      TT:=T-DT/2.;
      Case N of             // (X+T-ZF)/DL)
      1: begin          //Ex
         E:=EE;
         E1:=EE1;
         D1:=TY;
         D2:=TZ;
         H1:=HH1-FHZ(X,TT);
         H2:=HH2-FHZ(X,TT);
         H3:=HH3;
         H4:=HH4;
         end;
      2: begin           //Ey
         E:=EE-FY(XX,T);
         E1:=EE1-FY(X,T);
         D1:=TZ;
         D2:=TX ;
         H1:=HH1;
         H2:=HH2;
         H3:=HH3-FHZ(X-DX2,TT);
         H4:=HH4-FHZ(X+DX2,TT);
//         H3:=HH3-FHZ(X+DX2,TT);
//         H4:=HH4-FHZ(X-DX2,TT);
         end;
      3: begin           //Ez
         E:=EE;
         E1:=EE1;
         D1:=TX ;
         D2:=TY ;
         H1:=HH1;
         H2:=HH2;
         H3:=HH3;
         H4:=HH4;
         end;
      else
         //   
         H1:=0; H2:=0; H3:=0; H4:=0; E:=0; E1:=0; D1:=0; D2:=0;
      end;
      R:=R1-R2;
      IF(DT-R)>=0 then
            E:=(E1+((H1-H2)*D1-(H3-H4)*D2)*((DT-R)/DT))*R2/R1
            else
              E:=(E*R1+(E1*R2-E*R1)*(DT/R))/R1;

      case N of
       1: EE:=E;
       2: EE:=E+FY(XX,T+DT);
       3: EE:=E;
      end;

end;
//          AbsorpBordersSecondSpaceLimit;
Procedure GetBorderValuesForSecondAprox;
  var I,J,K, N: Integer;
begin
    //    
    //  RT-ABC
     for N:=2 to 2 do
      for J:=1 to YSize do for k:=1 to ZSize-1 do
          begin
           EZX1_3[N,J,K]:=EZX1_2[N,J,K];
           EZXN_3[N,J,K]:=EZXN_2[N,J,K];
          end;

     for N:= 2 to 2 do
      for J:=1 to YSize-1 do for k:=1 to ZSize do
          begin
           EYX1_3[n,J,K]:=EYX1_2[n,J,K];
           EYXN_3[n,J,K]:=EYXN_2[n,J,K];
          end;

     for N:=2 to 2 do
      for I:=1 to XSize do for k:=1 to ZSize-1 do
          begin
           EZY1_3[n,I,K]:=EZY1_2[n,I,K];
           EZYN_3[n,I,K]:=EZYN_2[n,I,K];
          end;

     for N:=2 to 2 do
      for I:=1 to XSize-1 do for k:=1 to ZSize do
          begin
           EXY1_3[n,I,K]:=EXY1_2[n,I,K];
           EXYN_3[n,I,K]:=EXYN_2[n,I,K];
          end;

     for N:=2 to 2 do
      for I:=1 to XSize do for J:=1 to YSize-1 do
          begin
           EYZ1_3[n,I,J]:=EYZ1_2[n,I,J];
           EYZN_3[n,I,J]:=EYZN_2[n,I,J];
          end;

     for N:=2 to 2 do
      for I:=1 to XSize-1 do for J:=1 to YSize do
          begin
           EXZ1_3[n,I,J]:=EXZ1_2[n,I,J];
           EXZN_3[n,I,J]:=EXZN_2[n,I,J];
          end;

    //    
     for N:=1 to 3 do
      for J:=1 to YSize do for k:=1 to ZSize-1 do
          begin
           EZX1_2[N,J,K]:=EZX1_1[N,J,K];
           EZXN_2[N,J,K]:=EZXN_1[N,J,K];
          end;

     for N:= 1 to 3 do
      for J:=1 to YSize-1 do for k:=1 to ZSize do
          begin
           EYX1_2[n,J,K]:=EYX1_1[n,J,K];
           EYXN_2[n,J,K]:=EYXN_1[n,J,K];
          end;

     for N:=1 to 3 do
      for I:=1 to XSize do for k:=1 to ZSize-1 do
          begin
           EZY1_2[n,I,K]:=EZY1_1[n,I,K];
           EZYN_2[n,I,K]:=EZYN_1[n,I,K];
          end;

     for N:=1 to 3 do
      for I:=1 to XSize-1 do for k:=1 to ZSize do
          begin
           EXY1_2[n,I,K]:=EXY1_1[n,I,K];
           EXYN_2[n,I,K]:=EXYN_1[n,I,K];
          end;

     for N:=1 to 3 do
      for I:=1 to XSize do for J:=1 to YSize-1 do
          begin
           EYZ1_2[n,I,J]:=EYZ1_1[n,I,J];
           EYZN_2[n,I,J]:=EYZN_1[n,I,J];
          end;

     for N:=1 to 3 do
      for I:=1 to XSize-1 do for J:=1 to YSize do
          begin
           EXZ1_2[n,I,J]:=EXZ1_1[n,I,J];
           EXZN_2[n,I,J]:=EXZN_1[n,I,J];
          end;

    //  a   c    (  Ey)
     for N:=1 to 3 do
      for J:=1 to YSize do for k:=1 to ZSize-1 do
          begin //    Ez
           EZX1_1[N,J,K]:=EZ[n,J,K];
           EZXN_1[N,J,K]:=EZ[XSize-n+1,J,K];
          end;
     for N:=1 to 3 do
      for J:=1 to YSize-1 do for k:=1 to ZSize do
          begin //    Ey

           EYX1_1[n,J,K]:=EY[n,J,K]-GetInputField(T-dT-(n-1)*dX,NoInput);
           EYXN_1[n,J,K]:=EY[XSize-n+1,J,K]-GetInputField(T-dT-(XSize-n)*dX,NoInput);
          end;

     for N:=1 to 3 do
      for I:=1 to XSize do for k:=1 to ZSize-1 do
          begin  //    Ez
           EZY1_1[n,I,K]:=EZ[I,n,K];
           EZYN_1[n,I,K]:=EZ[I,YSize-n+1,K];
          end;

     for N:=1 to 3 do
      for I:=1 to XSize-1 do for k:=1 to ZSize do
          begin  //    Ex
           EXY1_1[n,I,K]:=EX[I,n,K];
           EXYN_1[n,I,K]:=EX[I,YSize-n+1,K];
          end;

     for n:=1 to 3 do
      for I:=1 to XSize do for J:=1 to YSize-1 do
          begin //     Ey
           EYZ1_1[n,I,J]:=EY[I,J,n]-GetInputField(T-dT-(I-1)*dX,NoInput);          //???
           EYZN_1[n,I,J]:=EY[I,J,ZSize-n+1]-GetInputField(T-dT-(I-1)*dX,NoInput); //???
          end;                                    // X:=DX*(I-0.5);

     for N:=1 to 3 do
      for I:=1 to XSize-1 do for J:=1 to YSize do
          begin //     Ex
           EXZ1_1[n,I,J]:=EX[I,J,n];
           EXZN_1[n,I,J]:=EX[I,J,ZSize-n+1];
          end;
end;
   //*************************   2 ***************************
Procedure AbsorpSecondBordersSpaceLimit;
 var I,J,K: Integer;
     Eras: FloatType;
begin
  //   
  if (Absorp5_2)or(Absorp6_2) then begin
    K1:=(Tx-1)/(Tx+1);
    K2:=2/(Tx+1);
//    K3:=Tx*Tx/(2*(Tx+1));
//    K4:=Tx*Tx/(2*(Tx+1));

  if Absorp6_2 then  begin// 
      //Ez  
        //       
      X:=DX;
      XX:=0.0;
    K3:=0.5*dT*dT/(dY*dY)*dX/(dT+dX);
    K4:=0.5*dT*dT/(dZ*dZ)*dX/(dT+dX);
     for J:=2 to YSize-1 do
       for K:=2 to ZSize-2 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezx1_2[2,J,k],  Ez[2,J,k],       Ezx1_2[1,J,k],  Ezx1_1[1,J,k],
            Ezx1_1[2,J,k],  Ezx1_1[1,J+1,k], Ezx1_1[1,J,k],  Ezx1_1[1,J-1,k],
            Ezx1_1[2,J+1,k],Ezx1_1[2,J,k],   Ezx1_1[2,J-1,k],Ezx1_1[1,J,k+1],
            Ezx1_1[1,J,k],  Ezx1_1[1,J,k-1], Ezx1_1[2,J,k+1],Ezx1_1[2,J,k],
            Ezx1_1[2,J,k-1]);
        Ez[1,J,k]:=Eras;

        end;
        // Ez     
      for J:=2 to YSize-1 do begin
         K:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezx1_2[2,J,k],  Ez[2,J,k],       Ezx1_2[1,J,k],  Ezx1_1[1,J,k],
            Ezx1_1[2,J,k],0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[1,J,k]:=Eras;
         K:=ZSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezx1_2[2,J,k],  Ez[2,J,k],       Ezx1_2[1,J,k],  Ezx1_1[1,J,k],
            Ezx1_1[2,J,k],0,0,0,0,0,0,0,0,0,0,0,0);
       Ez[1,J,k]:=Eras;
      end;

      //Ey  
        //       
    K3:=0.5*dT*dT/(dZ*dZ)*dX/(dT+dX);
    K4:=0.5*dT*dT/(dY*dY)*dX/(dT+dX);
     for J:=2 to YSize-2 do
       for K:=2 to ZSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyx1_2[2,J,k],  Ey[2,J,k]-GetInputField(T-X,NoInput),   Eyx1_2[1,J,k],  Eyx1_1[1,J,k],
            Eyx1_1[2,J,k],  Eyx1_1[1,J,k+1], Eyx1_1[1,J,k],  Eyx1_1[1,J,k-1],
            Eyx1_1[2,J,k+1],Eyx1_1[2,J,k],   Eyx1_1[2,J,k-1],Eyx1_1[1,J+1,k],
            Eyx1_1[1,J,k],  Eyx1_1[1,J-1,k], Eyx1_1[2,J+1,k],Eyx1_1[2,J,k],
            Eyx1_1[2,J-1,k]);
        Ey[1,J,k]:=Eras+GetInputField(T,NoInput);
      end;
        // Ey     
      for K:=2 to ZSize-1 do begin
           j:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyx1_2[2,J,k],  Ey[2,J,k]-GetInputField(T-X,NoInput),   Eyx1_2[1,J,k],  Eyx1_1[1,J,k],
            Eyx1_1[2,J,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[1,J,k]:=Eras+GetInputField(T,NoInput);
           j:=YSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyx1_2[2,J,k],  Ey[2,J,k]-GetInputField(T-X,NoInput),   Eyx1_2[1,J,k],  Eyx1_1[1,J,k],
            Eyx1_1[2,J,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[1,J,k]:=Eras+GetInputField(T,NoInput);
      end;

       end; //if Absorp6_2

  if Absorp5_2 then  begin// 
      //Ez  
        //       
      X:=(XSize-1-1)*DX;
      XX:=X+DX;
    K3:=0.5*dT*dT/(dY*dY)*dX/(dT+dX);
    K4:=0.5*dT*dT/(dZ*dZ)*dX/(dT+dX);
     for J:=2 to YSize-1 do
       for K:=2 to ZSize-2 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzxN_2[2,J,k],  Ez[XSize-1,J,k], EzxN_2[1,J,k],  EzxN_1[1,J,k],
            EzxN_1[2,J,k],  EzxN_1[1,J+1,k], EzxN_1[1,J,k],  EzxN_1[1,J-1,k],
            EzxN_1[2,J+1,k],EzxN_1[2,J,k],   EzxN_1[2,J-1,k],EzxN_1[1,J,k+1],
            EzxN_1[1,J,k],  EzxN_1[1,J,k-1], EzxN_1[2,J,k+1],EzxN_1[2,J,k],
            EzxN_1[2,J,k-1]);
        Ez[XSize,J,k]:=Eras;
        end;
        // Ez     
      for J:=2 to YSize-1 do begin
        K:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzxN_2[2,J,k],  Ez[XSize-1,J,k], EzxN_2[1,J,k],  EzxN_1[1,J,k],
            EzxN_1[2,J,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[XSize,J,k]:=Eras;
        K:=ZSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzxN_2[2,J,k],  Ez[XSize-1,J,k], EzxN_2[1,J,k],  EzxN_1[1,J,k],
            EzxN_1[2,J,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[XSize,J,k]:=Eras;
      end;

      //Ey  
        //       
    K3:=0.5*dT*dT/(dZ*dZ)*dX/(dT+dX);
    K4:=0.5*dT*dT/(dY*dY)*dX/(dT+dX);
     for J:=2 to YSize-2 do
       for K:=2 to ZSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyxN_2[2,J,k],  Ey[XSize-1,J,k]-GetInputField(T-X,NoInput), EyxN_2[1,J,k],  EyxN_1[1,J,k],
            EyxN_1[2,J,k],  EyxN_1[1,J,k+1], EyxN_1[1,J,k],  EyxN_1[1,J,k-1],
            EyxN_1[2,J,k+1],EyxN_1[2,J,k],   EyxN_1[2,J,k-1],EyxN_1[1,J+1,k],
            EyxN_1[1,J,k],  EyxN_1[1,J-1,k], EyxN_1[2,J+1,k],EyxN_1[2,J,k],
            EyxN_1[2,J-1,k]);
        Ey[XSize,J,k]:=Eras+GetInputField(T-XX,NoInput);
        end;
        // Ey     
      for K:=2 to ZSize-1 do begin
           j:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyxN_2[2,J,k],  Ey[XSize-1,J,k]-GetInputField(T-X,NoInput),   EyxN_2[1,J,k], EyxN_1[1,J,k],
            EyxN_1[2,J,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[XSize,J,k]:=Eras+GetInputField(T-XX,NoInput);
           j:=YSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyxN_2[2,J,k],  Ey[XSize-1,J,k]-GetInputField(T-X,NoInput),   EyxN_2[1,J,k],  EyxN_1[1,J,k],
            EyxN_1[2,J,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[XSize,J,k]:=Eras+GetInputField(T-XX,NoInput);
      end;

       end; //if Absorp5_2
  end; //   

//===============     ===========================

  if (Absorp1_2)or(Absorp2_2) then begin
    K1:=(Ty-1)/(Ty+1);
    K2:=2/(Ty+1);

  if Absorp1_2 then  begin// 
      //Ez  
    K3:=0.5*dT*dT/(dX*dX)*dY/(dT+dY);
    K4:=0.5*dT*dT/(dZ*dZ)*dY/(dT+dY);
        //       
     for I:=2 to XSize-1 do
       for K:=2 to ZSize-2 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezy1_2[2,I,k],  Ez[I,2,k],       Ezy1_2[1,I,k],  Ezy1_1[1,I,k],
            Ezy1_1[2,I,k],  Ezy1_1[1,I+1,k], Ezy1_1[1,I,k],  Ezy1_1[1,I-1,k],
            Ezy1_1[2,I+1,k],Ezy1_1[2,I,k],   Ezy1_1[2,I-1,k],Ezy1_1[1,I,k+1],
            Ezy1_1[1,I,k],  Ezy1_1[1,I,k-1], Ezy1_1[2,I,k+1],Ezy1_1[2,I,k],
            Ezy1_1[2,I,k-1]);
        Ez[I,1,k]:=Eras;
        end;
        //      
        // Ez    
     for I:=2 to XSize-1 do begin
            k:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezy1_2[2,I,k],  Ez[I,2,k],       Ezy1_2[1,I,k],  Ezy1_1[1,I,k],
            Ezy1_1[2,I,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[I,1,k]:=Eras;
            k:=ZSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezy1_2[2,I,k],  Ez[I,2,k],       Ezy1_2[1,I,k],  Ezy1_1[1,I,k],
            Ezy1_1[2,I,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[I,1,k]:=Eras;
      end;

      //Ex  
        //       
    K3:=0.5*dT*dT/(dZ*dZ)*dY/(dT+dY);
    K4:=0.5*dT*dT/(dX*dX)*dY/(dT+dY);
     for I:=2 to XSize-2 do
       for K:=2 to ZSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exy1_2[2,I,k],  Ex[I,2,k],       Exy1_2[1,I,k],  Exy1_1[1,I,k],
            Exy1_1[2,I,k],  Exy1_1[1,I,k+1], Exy1_1[1,I,k],  Exy1_1[1,I,k-1],
            Exy1_1[2,I,k+1],Exy1_1[2,I,k],   Exy1_1[2,I,k-1],Exy1_1[1,I+1,k],
            Exy1_1[1,I,k],  Exy1_1[1,I-1,k], Exy1_1[2,I+1,k],Exy1_1[2,I,k],
            Exy1_1[2,I-1,k]);
        Ex[I,1,k]:=Eras;
        end;
        // Ex    
     for K:=2 to ZSize-1 do begin
         I:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exy1_2[2,I,k],  Ex[I,2,k],       Exy1_2[1,I,k],  Exy1_1[1,I,k],
            Exy1_1[2,I,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ex[I,1,k]:=Eras;
         I:=XSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exy1_2[2,I,k],  Ex[I,2,k],       Exy1_2[1,I,k],  Exy1_1[1,I,k],
            Exy1_1[2,I,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ex[I,1,k]:=Eras;
     end;


       end; //if Absorp1_2
    // -----------------------------
  if Absorp2_2 then  begin// 
      //Ez  
        //       
    K3:=0.5*dT*dT/(dX*dX)*dY/(dT+dY);
    K4:=0.5*dT*dT/(dZ*dZ)*dY/(dT+dY);
     for I:=2 to XSize-1 do
       for K:=2 to ZSize-2 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzyN_2[2,I,k],  Ez[I,YSize-1,k],       EzyN_2[1,I,k],  EzyN_1[1,I,k],
            EzyN_1[2,I,k],  EzyN_1[1,I+1,k], EzyN_1[1,I,k],  EzyN_1[1,I-1,k],
            EzyN_1[2,I+1,k],EzyN_1[2,I,k],   EzyN_1[2,I-1,k],EzyN_1[1,I,k+1],
            EzyN_1[1,I,k],  EzyN_1[1,I,k-1], EzyN_1[2,I,k+1],EzyN_1[2,I,k],
            EzyN_1[2,I,k-1]);
        Ez[I,YSize,k]:=Eras;
        end;
        //      
       // Ez    
      for I:=2 to XSize-1 do begin
            k:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzyN_2[2,I,k],  Ez[I,YSize-1,k],       EzyN_2[1,I,k],  EzyN_1[1,I,k],
            EzyN_1[2,I,k],    0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[I,YSize,k]:=Eras;
            k:=ZSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzyN_2[2,I,k],  Ez[I,YSize-1,k],       EzyN_2[1,I,k],  EzyN_1[1,I,k],
            EzyN_1[2,I,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[I,YSize,k]:=Eras;
      end;

      //Ex  
        //       
    K3:=0.5*dT*dT/(dZ*dZ)*dY/(dT+dY);
    K4:=0.5*dT*dT/(dX*dX)*dY/(dT+dY);
     for I:=2 to XSize-2 do
       for K:=2 to ZSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExyN_2[2,I,k],  Ex[I,YSize-1,k],       ExyN_2[1,I,k],  ExyN_1[1,I,k],
            ExyN_1[2,I,k],  ExyN_1[1,I,k+1], ExyN_1[1,I,k],  ExyN_1[1,I,k-1],
            ExyN_1[2,I,k+1],ExyN_1[2,I,k],   ExyN_1[2,I,k-1],ExyN_1[1,I+1,k],
            ExyN_1[1,I,k],  ExyN_1[1,I-1,k], ExyN_1[2,I+1,k],ExyN_1[2,I,k],
            ExyN_1[2,I-1,k]);
        Ex[I,YSize,k]:=Eras;
        end;
        //      
        // Ex    
     for K:=2 to ZSize-1 do begin
         I:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExyN_2[2,I,k],  Ex[I,YSize-1,k],       ExyN_2[1,I,k],  ExyN_1[1,I,k],
            ExyN_1[2,I,k],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ex[I,YSize,k]:=Eras;
         I:=XSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExyN_2[2,I,k],  Ex[I,YSize-1,k],       ExyN_2[1,I,k],  ExyN_1[1,I,k],
            ExyN_1[2,I,k],   0,0,0,0,0,0,0,0,0,0,0,0);
        Ex[I,YSize,k]:=Eras;
      end;

       end; //if Absorp2_2
  end; //   

//====================   ==================
  if (Absorp4_2)or(Absorp3_2) then begin
    K1:=(Tz-1)/(Tz+1);
    K2:=2/(Tz+1);
//    K3:=Tz*Tz/(2*(Tz+1));
//    K4:=Tz*Tz/(2*(Tz+1));
    K3:=0.5*dT*dT/(dX*dX)*dZ/(dT+dZ);
    K4:=0.5*dT*dT/(dY*dY)*dZ/(dT+dZ);

  if Absorp4_2 then  begin// 
      //Ex  
        //       
     for I:=2 to XSize-2 do
       for J:=2 to YSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exz1_2[2,I,J],  Ex[I,J,2],       Exz1_2[1,I,J],  Exz1_1[1,I,J],
            Exz1_1[2,I,J],  Exz1_1[1,I+1,J], Exz1_1[1,I,J],  Exz1_1[1,I-1,J],
            Exz1_1[2,I+1,J],Exz1_1[2,I,J],   Exz1_1[2,I-1,J],Exz1_1[1,I,J+1],
            Exz1_1[1,I,J],  Exz1_1[1,I,J-1], Exz1_1[2,I,J+1],Exz1_1[2,I,J],
            Exz1_1[2,I,J-1]);
        Ex[I,J,1]:=Eras;
        end;
        // Ex     
      for J:=2 to YSize-1 do begin
           I:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exz1_2[2,I,J],  Ex[I,J,2],  Exz1_2[1,I,J],  Exz1_1[1,I,J],
            Exz1_1[2,I,J],0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,1]:=Eras;
           I:=XSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exz1_2[2,I,J],  Ex[I,J,2],  Exz1_2[1,I,J],  Exz1_1[1,I,J],
            Exz1_1[2,I,J],0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,1]:=Eras;
      end;

      //Ey   
    K3:=0.5*dT*dT/(dx*dX)*dZ/(dT+dZ);
    K4:=0.5*dT*dT/(dY*dY)*dZ/(dT+dZ);
        //       
     for I:=2 to XSize-1 do
       for J:=2 to YSize-2 do begin
          X:=dX*(I-1);
          XX:=X;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyz1_2[2,I,J],  Ey[I,J,2]-GetInputField(T-X,NoInput),    Eyz1_2[1,I,J],  Eyz1_1[1,I,J],
            Eyz1_1[2,I,J],  Eyz1_1[1,I+1,J], Eyz1_1[1,I,J],  Eyz1_1[1,I-1,J],
            Eyz1_1[2,I+1,J],Eyz1_1[2,I,J],   Eyz1_1[2,I-1,J],Eyz1_1[1,I,J+1],
            Eyz1_1[1,I,J],  Eyz1_1[1,I,J-1], Eyz1_1[2,I,J+1],Eyz1_1[2,I,J],
            Eyz1_1[2,I,J-1]);
        Ey[I,J,1]:=Eras+GetInputField(T-X,NoInput);
        end;
        //      
      for I:=2 to XSize-1 do begin
      X:=DX*(I-1);
      XX:=X;
      j:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyz1_2[2,I,J],  Ey[I,J,2]-GetInputField(T-X,NoInput),    Eyz1_2[1,I,J],  Eyz1_1[1,I,J],
            Eyz1_1[2,I,J],0,0,0,0,0,0,  0,0,0,0,0,0);
        Ey[I,J,1]:=Eras+GetInputField(T-X,NoInput);
      j:=YSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyz1_2[2,I,J],  Ey[I,J,2]-GetInputField(T-X,NoInput),    Eyz1_2[1,I,J],  Eyz1_1[1,I,J],
            Eyz1_1[2,I,J],0,0,0,0,0,0,  0,0,0,0,0,0);
        Ey[I,J,1]:=Eras+GetInputField(T-X,NoInput);
      end;
    end; //if Absorp4_2 ()

  if Absorp3_2 then  begin// 
      //Ex  
        //       
    K3:=0.5*dT*dT/(dX*dX)*dZ/(dT+dZ);
    K4:=0.5*dT*dT/(dY*dY)*dZ/(dT+dZ);
     for I:=2 to XSize-2 do
       for J:=2 to YSize-1 do begin
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExzN_2[2,I,J],  Ex[I,J,ZSize-1],       ExzN_2[1,I,J],  ExzN_1[1,I,J],
            ExzN_1[2,I,J],  ExzN_1[1,I+1,J], ExzN_1[1,I,J],  ExzN_1[1,I-1,J],
            ExzN_1[2,I+1,J],ExzN_1[2,I,J],   ExzN_1[2,I-1,J],ExzN_1[1,I,J+1],
            ExzN_1[1,I,J],  ExzN_1[1,I,J-1], ExzN_1[2,I,J+1],ExzN_1[2,I,J],
            ExzN_1[2,I,J-1]);
        Ex[I,J,ZSize]:=Eras;
        end;
        //      
      for J:=2 to YSize-1 do begin
        I:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExzN_2[2,I,J],  Ex[I,J,ZSize-1],       ExzN_2[1,I,J],  ExzN_1[1,I,J],
            ExzN_1[2,I,J], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,ZSize]:=Eras;
        I:=XSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExzN_2[2,I,J],  Ex[I,J,ZSize-1],       ExzN_2[1,I,J],  ExzN_1[1,I,J],
            ExzN_1[2,I,J], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,ZSize]:=Eras;
      end;

      //Ey   
        //       
    K3:=0.5*dT*dT/(dX*dX)*dZ/(dT+dZ);
    K4:=0.5*dT*dT/(dY*dY)*dZ/(dT+dZ);
     for I:=2 to XSize-1 do
       for J:=2 to YSize-2 do begin
          X:=dX*(I-1);
          XX:=X;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyzN_2[2,I,J],  Ey[I,J,ZSize-1]-GetInputField(T-X,NoInput),    EyzN_2[1,I,J],  EyzN_1[1,I,J],
            EyzN_1[2,I,J],  EyzN_1[1,I+1,J], EyzN_1[1,I,J],  EyzN_1[1,I-1,J],
            EyzN_1[2,I+1,J],EyzN_1[2,I,J],   EyzN_1[2,I-1,J],EyzN_1[1,I,J+1],
            EyzN_1[1,I,J],  EyzN_1[1,I,J-1], EyzN_1[2,I,J+1],EyzN_1[2,I,J],
            EyzN_1[2,I,J-1]);
        Ey[I,J,ZSize]:=Eras+GetInputField(T-X,NoInput);
        end;
        //      
      for I:=2 to XSize-1 do begin
      X:=DX*(I-1);
      XX:=X;
      J:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyzN_2[2,I,J],  Ey[I,J,ZSize-1]-GetInputField(T-X,NoInput),    EyzN_2[1,I,J],  EyzN_1[1,I,J],
            EyzN_1[2,I,J],   0,0,0,0,0,0,  0,0,0,0,0,0);
        Ey[I,J,ZSize]:=Eras+GetInputField(T-X,NoInput);
      J:=YSize-1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyzN_2[2,I,J],  Ey[I,J,ZSize-1]-GetInputField(T-X,NoInput),    EyzN_2[1,I,J],  EyzN_1[1,I,J],
            EyzN_1[2,I,J],   0,0,0,0,0,0,  0,0,0,0,0,0);
        Ey[I,J,ZSize]:=Eras+GetInputField(T-X,NoInput);
      end;

   end; //if Absorp3_2 ()

 end; //   

 //==================    ===================
  //    
  if (Absorp5_2)or(Absorp6_2) then begin
    K1:=(Tx-1)/(Tx+1);
    K2:=2/(Tx+1);
    K3:=0;
    K4:=0;

  if Absorp6_2 then  begin// 
    // ,   Z
      for K:=1 to ZSize-1 do begin
        J:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezx1_2[1,J+1,k],  Ez[1,J+1,k],  Ezx1_2[1,J,k],  Ezx1_1[1,J,k],
            Ezx1_1[1,J+1,k],0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[1,J,k]:=Eras;
        J:=YSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Ezx1_2[1,J-1,k],  Ez[1,J-1,k],  Ezx1_2[1,J,k],  Ezx1_1[1,J,k],
            Ezx1_1[1,J-1,k],0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[1,J,k]:=Eras;
      end;
        //      .  
     // ,   Y
      for J:=1 to YSize-1 do begin
        K:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyx1_2[1,J,K+1],  Ey[1,J,K+1]-GetInputField(T,NoInput), Eyx1_2[1,J,k],  Eyx1_1[1,J,k],
            Eyx1_1[1,J,k+1],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[1,J,k]:=Eras+GetInputField(T,NoInput);
        K:=ZSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Eyx1_2[1,J,K-1],  Ey[1,J,K-1]-GetInputField(T,NoInput), Eyx1_2[1,J,k],  Eyx1_1[1,J,k],
            Eyx1_1[1,J,k-1],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[1,J,k]:=Eras+GetInputField(T,NoInput);
      end;
   end;

  if  Absorp5_2 then  begin// 
    // ,   Z
      for K:=1 to ZSize-1 do begin
        J:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzxN_2[1,J+1,k],  Ez[XSize,J+1,k],  EzxN_2[1,J,k],  EzxN_1[1,J,k],
            EzxN_1[1,J+1,k],0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[XSize,J,k]:=Eras;
        J:=YSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EzxN_2[1,J-1,k],  Ez[XSize,J-1,k],  EzxN_2[1,J,k],  EzxN_1[1,J,k],
            EzxN_1[1,J-1,k],0,0,0,0,0,0,0,0,0,0,0,0);
        Ez[XSize,J,k]:=Eras;
      end;
        //      .  
     // ,   Y
      for J:=1 to YSize-1 do begin
        K:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyxN_2[1,J,K+1],  Ey[XSize,J,K+1]-GetInputField(T-(XSize-1)*DX,NoInput), EyxN_2[1,J,k],  EyxN_1[1,J,k],
            EyxN_1[1,J,k+1],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[XSize,J,k]:=Eras+GetInputField(T-(XSize-1)*DX,NoInput);
        K:=ZSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            EyxN_2[1,J,K-1],  Ey[XSize,J,K-1]-GetInputField(T-(XSize-1)*DX,NoInput), EyxN_2[1,J,k],  EyxN_1[1,J,k],
            EyxN_1[1,J,k-1],  0,0,0,0,0,0,0,0,0,0,0,0);
        Ey[XSize,J,k]:=Eras+GetInputField(T-(XSize-1)*DX,NoInput);
      end;
  end;
 end;

  //   ( Ex)
  if Absorp3_2 then  begin// 
    K1:=(Tx-1)/(Tx+1);
    K2:=2/(Tx+1);
    K3:=0;
    K4:=0;
      for I:=2 to XSize-1 do begin
        J:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExzN_2[1,I,J+1],  Ex[I,J+1,ZSize],  ExzN_2[1,I,J],  ExzN_1[1,I,J],
            ExzN_1[1,I,J+1], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,ZSize]:=Eras;
        J:=YSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            ExzN_2[1,I,J-1],  Ex[I,J-1,ZSize],  ExzN_2[1,I,J],  ExzN_1[1,I,J],
            ExzN_1[1,I,J-1], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,ZSize]:=Eras;
      end;
   end;
  //   ( Ex)
  if Absorp4_2 then  begin// 
    K1:=(Tx-1)/(Tx+1);
    K2:=2/(Tx+1);
    K3:=0;
    K4:=0;
      for I:=2 to XSize-1 do begin
        J:=1;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exz1_2[1,I,J+1],  Ex[I,J+1,1],  Exz1_2[1,I,J],  Exz1_1[1,I,J],
            Exz1_1[1,I,J+1], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,1]:=Eras;
        J:=YSize;
        Eras:= NS_AbsorptionSecond(K1,K2,K3,K4,
            Exz1_2[1,I,J-1],  Ex[I,J-1,1],  Exz1_2[1,I,J],  Exz1_1[1,I,J],
            Exz1_1[1,I,J-1], 0,0,0,0,0,0,  0,0,0,0,0,0);
        Ex[I,J,1]:=Eras;
      end;
   end;

end;
Function NS_AbsorptionSecond(K1,K2,K3,K4,E1,E2,E3,E4,E5,E6,E7,E8,E9,E10,E11,E12,E13,E14,E15,E16,E17: FloatType):FloatType;
begin
//  K3:=0;
  Result:=-E1+K1*(E2+E3)+K2*(E4+E5)
        + K3*(E6-2*E7+E8+E9-2*E10+E11)
        + K4*(E12-2*E13+E14+E15-2*E16+E17);
end;
//         2 
Procedure NS_AbsorptionFirst(var EE: FloatType;EE1,H: FloatType; N,M: integer);
  var E,E1,H1: FloatType;

  function FY(X,T: FloatType): FloatType;
  begin
   result:=GetInputField(T-X,NoInput);
  end;

begin
      E:=0;E1:=0;H1:=0;
      TT:=T-DT;
      case N of
           1:    begin   //Ex
                 E:=EE;
                 E1:=EE1;
                 H1:=H;
                 end;
           2:    begin   //Ey
                 E:=EE-FY(Xx,TT);
                 E1:=EE1-FY(x,T);
                 H1:=H;
                 end;
           3:    begin   //Ez
                 E:=EE;
                 E1:=EE1;
                 H1:=H;
                 end;
            end;

      case M of
           1:   E:=H1+(TX-1)/(TX+1)*(E1-E);
           2:   E:=H1+(TY-1)/(TY+1)*(E1-E);
           3:   E:=H1+(TZ-1)/(TZ+1)*(E1-E);
           end;

      case N of
          1:    EE:=E;
          2:    EE:=E+FY(Xx,T);
          3:    EE:=E;
          end;
end;

Procedure BordersSimmetryE;
  var I,J,K: Integer;
begin
  //     H
  if Simmetry1 then
     begin
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do   EX[I,1,K]:=-EX[I,3,K];
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do     EZ[I,1,K]:=-EZ[I,3,K];
     end;
  //      H
  if Simmetry2 then
     begin
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do   EX[I,YSize,K]:=-EX[I,YSize-2,K];
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do     EZ[I,YSize,K]:=-EZ[I,YSize-2,K];
     end;

  //      E
  if Simmetry3 then
     begin
         For J:=1 to YSize do
            For I:=1 to XSize-1 do  begin
               EX[I,J,ZSize]:=EX[I,J,ZSize-2];
               end;
         For J:=1 to YSize-1 do
            For I:=1 to XSize do   begin
                EY[I,J,ZSize]:=EY[I,J,ZSize-2];
                end;
    end;
  //       E
  if Simmetry4 then
     begin
         For J:=1 to YSize do
            For I:=1 to XSize-1 do  begin
                 EX[I,J,1]:=EX[I,J,3];
                 end;
         For J:=1 to YSize-1 do
            For I:=1 to XSize do  begin
                  EY[I,J,1]:=EY[I,J,3];
                  end;
     end;
end;

Procedure BordersSimmetryH;
  var I,J,K: Integer;
begin
  //     H
  if Simmetry1 then
     begin
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do   HX[I,1,K]:=HX[I,2,K];
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do     HZ[I,1,K]:=HZ[I,2,K];
     end;                  
  //      H
  if Simmetry2 then
     begin
         For K:=1 to ZSize-1 do
            For I:=1 to XSize do   HX[I,YSize-1,K]:=HX[I,YSize-2,K];
         For K:=1 to ZSize do
            For I:=1 to XSize-1 do     HZ[I,YSize-1,K]:=HZ[I,YSize-2,K];
     end;

  //      E
  if Simmetry3 then
     begin
         For J:=1 to YSize-1 do
            For I:=1 to XSize do   HX[I,J,ZSize-1]:=-HX[I,J,ZSize-2];
         For J:=1 to YSize do
            For I:=1 to XSize-1 do   HY[I,J,ZSize-1]:=-HY[I,J,ZSize-2];
     end;

  //       E
  if Simmetry4 then
     begin
         For J:=1 to YSize-1 do
            For I:=1 to XSize do   HX[I,J,1]:=-HX[I,J,2];
         For J:=1 to YSize do
            For I:=1 to XSize-1 do   HY[I,J,1]:=-HY[I,J,2];
     end;
end;
//=============================================================================
                          //   RT-ABC
Procedure RT_ABC;
  var I,J,K: Integer;
begin
   //      .
   //     -   
  //   
 // Ez    YxZ (  )
  if (RT5)or(RT6) then
      for J:=2 to YSize-1 do
      for K:=1 to ZSize-1 do begin
      if (RT6) then
         EZ[1,J,K]:=EZX1_2[2,J,K]+0.5*(EZX1_2[1,J,K]-EZX1_2[3,J,K])+(EZX1_1[2,J,K]-EZX1_3[2,J,K]);
      if (RT5) then
         EZ[XSize,J,K]:=EZXN_2[2,J,K]+0.5*(EZXN_2[1,J,K]-EZXN_2[3,J,K])+(EZXN_1[2,J,K]-EZXN_3[2,J,K]);
      end;

 // Ey    YxZ [  ]
      X:=(XSize-1-1)*DX;
      XX:=X+DX;
  if (RT5)or(RT6) then
      for J:=1 to YSize-1 do
      for K:=2 to ZSize-1 do begin
      if (RT6) then
         EY[1,J,K]:=EYX1_2[2,J,K]+0.5*(EYX1_2[1,J,K]-EYX1_2[3,J,K])+(EYX1_1[2,J,K]-EYX1_3[2,J,K])
             +GetInputField(T,NoInput);
      if (RT5) then
         EY[XSize,J,K]:=EYXN_2[2,J,K]+0.5*(EYXN_2[1,J,K]-EYXN_2[3,J,K])+(EYXN_1[2,J,K]-EYXN_3[2,J,K])
                   +GetInputField(T-XX,NoInput);
      end;

  //   
 // Ex    XxZ [  ]
  if (RT1)or(RT2) then
      for K:=2 to ZSize-1 do
      for I:=1 to XSize-1 do begin
      if (RT1) then
         EX[I,1,K]:=EXY1_2[2,I,K]+0.5*(EXY1_2[1,I,K]-EXY1_2[3,I,K])+(EXY1_1[2,I,K]-EXY1_3[2,I,K]);
//             EX[I,1,K]:=  EXY1[I,K]+(Ty-1)/(Ty+1)*(EX[I,2,K]-EX[I,1,K]);
      if (RT2) then
         EX[I,YSize,K]:=EXYN_2[2,I,K]+0.5*(EXYN_2[1,I,K]-EXYN_2[3,I,K])+(EXYN_1[2,I,K]-EXYN_3[2,I,K]);
//             EX[I,YSize,K]:=  EXYN[I,K]+(Ty-1)/(Ty+1)*(EX[I,YSize-1,K]-EX[I,YSize,K]);
      end;

 // Ez    XxZ [  ]
  if (RT1)or(RT2) then
      for K:=1 to ZSize-1 do
      for I:=2 to XSize-1 do begin
      if (RT1) then
         EZ[I,1,K]:=EZY1_2[2,I,K]+0.5*(EZY1_2[1,I,K]-EZY1_2[3,I,K])+(EZY1_1[2,I,K]-EZY1_3[2,I,K]);
//           EZ[I,1,K]:=  EZY1[I,K]+(Ty-1)/(Ty+1)*(EZ[I,2,K]-EZ[I,1,K]);
      if (RT2) then
         EZ[I,YSize,K]:=EZYN_2[2,I,K]+0.5*(EZYN_2[1,I,K]-EZYN_2[3,I,K])+(EZYN_1[2,I,K]-EZYN_3[2,I,K]);
//             EZ[I,YSize,K]:=  EZYN[I,K]+(Ty-1)/(Ty+1)*(EZ[I,YSize-1,K]-EZ[I,YSize,K]);
      end;

  //   
 // Ey    XxY [  ]
  if (RT3)or(RT4) then
      for I:=2 to XSize-1 do
      for J:=1 to YSize-1 do begin
      if (RT3) then
         EY[I,J,ZSize]:=EYZN_2[2,I,J]+0.5*(EYZN_2[1,I,J]-EYZN_2[3,I,J])+(EYZN_1[2,I,J]-EYZN_3[2,I,J])
                  +GetInputField(T-(I-1)*DX,NoInput);
//            EY[I,J,ZSize]:=EYZN[I,J]+(Tz-1)/(Tz+1)*(EY[I,J,ZSize-1]-GetInputField(T-(I-1)*DX)-EY[I,J,ZSize]+GetInputField(T-(I-1)*DX-dT))
//                +GetInputField(T-(I-1)*DX);
      if (RT4) then
         EY[I,J,1]:=EYZ1_2[2,I,J]+0.5*(EYZ1_2[1,I,J]-EYZ1_2[3,I,J])+(EYZ1_1[2,I,J]-EYZ1_3[2,I,J])
                  +GetInputField(T-(I-1)*DX,NoInput);
//              EY[I,J,1]:=EYZ1[I,J]+(Tz-1)/(Tz+1)*(EY[I,J,2]-GetInputField(T-(I-1)*DX)-EY[I,J,1]+GetInputField(T-(I-1)*DX-dT))
//                  +GetInputField(T-(I-1)*DX);
      end;

 // Ex    XxY [  ]
  if (RT3)or(RT4) then
      for I:=1 to XSize-1 do
      for J:=2 to YSize-1 do begin
      if (RT3) then
         EX[I,J,ZSize]:=EXZN_2[2,I,J]+0.5*(EXZN_2[1,I,J]-EXZN_2[3,I,J])+(EXZN_1[2,I,J]-EXZN_3[2,I,J]);
//          EX[I,J,ZSize]:=  EXZN[I,J]+(Tz-1)/(Tz+1)*(EX[I,J,ZSize-1]-EX[I,J,ZSize]);
      if (RT4) then
         EX[I,J,1]:=EXZ1_2[2,I,J]+0.5*(EXZ1_2[1,I,J]-EXZ1_2[3,I,J])+(EXZ1_1[2,I,J]-EXZ1_3[2,I,J]);
//          EX[I,J,1]:=  EXZ1[I,J]+(Tz-1)/(Tz+1)*(EX[I,J,2]-EX[I,J,1]);
      end;

// ,   Z
  if (RT6)or(RT5) then
      for K:=1 to ZSize-1 do begin
       J:=1;
      if RT6 then
//       EZ[1,J,K]:=EZX1_2[1,J+1,K]+0.5*(EZX1_2[1,J,K]-EZX1_2[1,J+2,K])+(EZX1_1[1,J+1,K]-EZX1_3[1,J+1,K]);
         EZ[1,J,K]:=EZX1_2[2,J,K]+0.5*(EZX1_2[1,J,K]-EZX1_2[3,J,K])+(EZX1_1[2,J,K]-EZX1_3[2,J,K]);
       J:=YSize;
      if RT6 then
//       EZ[1,J,K]:=EZX1_2[1,J-1,K]+0.5*(EZX1_2[1,J,K]-EZX1_2[1,J-2,K])+(EZX1_1[1,J-1,K]-EZX1_3[1,J-1,K]);
         EZ[1,J,K]:=EZX1_2[2,J,K]+0.5*(EZX1_2[1,J,K]-EZX1_2[3,J,K])+(EZX1_1[2,J,K]-EZX1_3[2,J,K]);
       J:=1;
      if RT5 then
//       EZ[1,J,K]:=EZXN_2[1,J+1,K]+0.5*(EZXN_2[1,J,K]-EZXN_2[1,J+2,K])+(EZXN_1[1,J+1,K]-EZXN_3[1,J+1,K]);
         EZ[XSize,J,K]:=EZXN_2[2,J,K]+0.5*(EZXN_2[1,J,K]-EZXN_2[3,J,K])+(EZXN_1[2,J,K]-EZXN_3[2,J,K]);
       J:=YSize;
      if RT5 then
//       EZ[1,J,K]:=EZXN_2[1,J-1,K]+0.5*(EZXN_2[1,J,K]-EZXN_2[1,J-2,K])+(EZXN_1[1,J-1,K]-EZXN_3[1,J-1,K]);
         EZ[XSize,J,K]:=EZXN_2[2,J,K]+0.5*(EZXN_2[1,J,K]-EZXN_2[3,J,K])+(EZXN_1[2,J,K]-EZXN_3[2,J,K]);
      end;

// ,   Y
  if (RT6)or(RT5) then
      for J:=1 to YSize-1 do begin
      K:=1;
      if RT6 then
//         EY[1,J,K]:=EYX1_2[1,J,K+1]+0.5*(EYX1_2[1,J,K]-EYX1_2[1,J,K+2])+(EYX1_1[1,J,K+1]-EYX1_3[1,J,K+1])
//             +GetInputField(T);
         EY[1,J,K]:=EYX1_2[2,J,K]+0.5*(EYX1_2[1,J,K]-EYX1_2[3,J,K])+(EYX1_1[2,J,K]-EYX1_3[2,J,K])
             +GetInputField(T,NoInput);
      K:=ZSize;
      if RT6 then
//         EY[1,J,K]:=EYX1_2[1,J,K-1]+0.5*(EYX1_2[1,J,K]-EYX1_2[1,J,K-2])+(EYX1_1[1,J,K-1]-EYX1_3[1,J,K-1])
//             +GetInputField(T);
         EY[1,J,K]:=EYX1_2[2,J,K]+0.5*(EYX1_2[1,J,K]-EYX1_2[3,J,K])+(EYX1_1[2,J,K]-EYX1_3[2,J,K])
             +GetInputField(T,NoInput);
      K:=1;
      if RT5 then
//         EY[1,J,K]:=EYXN_2[1,J,K+1]+0.5*(EYXN_2[1,J,K]-EYXN_2[1,J,K+2])+(EYXN_1[1,J,K+1]-EYXN_3[1,J,K+1])
//                   +GetInputField(T-(XSize-1)*DX);
         EY[XSize,J,K]:=EYXN_2[2,J,K]+0.5*(EYXN_2[1,J,K]-EYXN_2[3,J,K])+(EYXN_1[2,J,K]-EYXN_3[2,J,K])
                   +GetInputField(T-(XSize-1)*DX,NoInput);
      K:=ZSize;
      if RT5 then
//         EY[1,J,K]:=EYXN_2[1,J,K-1]+0.5*(EYXN_2[1,J,K]-EYXN_2[1,J,K-2])+(EYXN_1[1,J,K-1]-EYXN_3[1,J,K-1])
//                   +GetInputField(T-(XSize-1)*DX);
         EY[XSize,J,K]:=EYXN_2[2,J,K]+0.5*(EYXN_2[1,J,K]-EYXN_2[3,J,K])+(EYXN_1[2,J,K]-EYXN_3[2,J,K])
                 +GetInputField(T-(XSize-1)*DX,NoInput);
      end;

// ,   X
  if (RT1)or(RT2) then
      for I:=1 to XSize-1 do begin
       K:=1;
      if RT1 then
         EX[I,1,K]:=EXY1_2[2,I,K]+0.5*(EXY1_2[1,I,K]-EXY1_2[3,I,K])+(EXY1_1[2,I,K]-EXY1_3[2,I,K]);
       K:=ZSize;
      if RT1 then
         EX[I,1,K]:=EXY1_2[2,I,K]+0.5*(EXY1_2[1,I,K]-EXY1_2[3,I,K])+(EXY1_1[2,I,K]-EXY1_3[2,I,K]);
       K:=1;
      if RT2 then
         EX[I,YSize,K]:=EXYN_2[2,I,K]+0.5*(EXYN_2[1,I,K]-EXYN_2[3,I,K])+(EXYN_1[2,I,K]-EXYN_3[2,I,K]);
       K:=ZSize;
      if RT2 then
          EX[I,YSize,K]:=EXYN_2[2,I,K]+0.5*(EXYN_2[1,I,K]-EXYN_2[3,I,K])+(EXYN_1[2,I,K]-EXYN_3[2,I,K]);
      end;
end;
//  
Procedure CalculateSar(bA,bB,bC,bD,bEnergy: boolean);
 var I, J, K: Integer;
     NowE: real;
     SumE, SumEkvadrat: real;
begin
 if bA or bB then begin //          
   For I:= 1 to XSize-1      do
      For j:= 1 to YSize-1    do
         For k:= 1 to ZSize-1   do
            if fmOpenGL.Space[i,j,k]<>0 then
              begin
                //  E   
                NowE:=Sqrt(Sqr(Ex[i,j,k])+Sqr(Ey[i,j,k])+Sqr(Ez[i,j,k]));
                if  MaxEArray[i,j,k]<NowE then MaxEArray[i,j,k]:=NowE;
              end;
   end; //if bA or bB

 if bC or bD then begin //        
   SumE:=0;
   SumEkvadrat:=0;
   For I:= 1 to XSize-1      do
      For j:= 1 to YSize-1    do
         For k:= 1 to ZSize-1   do
            if fmOpenGL.Space[i,j,k]<>0 then
              begin
                if bC then begin
                    //     
                    NowE:=Sqrt(Sqr(Ex[i,j,k])+Sqr(Ey[i,j,k])+Sqr(Ez[i,j,k]))*Sig[i,j,k];
                    SumE:=SumE+NowE;
                    end;
                if bD then begin
                    //    
                    NowE:=(Sqr(Ex[i,j,k])+Sqr(Ey[i,j,k])+Sqr(Ez[i,j,k]))*Sig[i,j,k];
                    SumEkvadrat:=SumEkvadrat+NowE;;
                    end;
              end;
   if  MaxJ<SumE then MaxJ:=SumE;
   if  MaxSar<SumEkvadrat then MaxSar:=SumEkvadrat;
   end; //if bC or bD

 if bEnergy then begin //    
   For I:= 1 to XSize-1      do
      For j:= 1 to YSize-1    do
         For k:= 1 to ZSize-1   do
            if fmOpenGL.Space[i,j,k]<>0 then
              begin
                Energy:=Energy+(Sqr(Ex[i,j,k])+Sqr(Ey[i,j,k])+Sqr(Ez[i,j,k]))*Sig[i,j,k]*dV*dTcek;
              end;
   end; //if bEnergy
end;

end.


